/**
 * Get the query builder to use for the provided crud and options
 *
 * @param {import("../../types/advanced-types.d.ts").NamedType<import("../generated/common/types.d.ts").StructureCrudDefinition>} crud
 * @param {{
 *   includeOwnParam: boolean,
 *   includeJoins: boolean,
 *   traverseParents: boolean,
 *   partial?: Record<string, any>,
 * }} options
 * @returns {string}
 */
export function crudQueryBuilderGet(crud: import("../../types/advanced-types.d.ts").NamedType<import("../generated/common/types.d.ts").StructureCrudDefinition>, options: {
    includeOwnParam: boolean;
    includeJoins: boolean;
    traverseParents: boolean;
    partial?: Record<string, any>;
}): string;
