/**
 * @param {import("../common/types.js").StructureAnyDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureAnyDefinition, ValidatorErrorMap>}
 */
export function validateStructureAnyDefinition(value: import("../common/types.js").StructureAnyDefinitionInput | any): Either<import("../common/types.js").StructureAnyDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureAnyDefinitionTarget|any} value
 * @returns {Either<import("../common/types.js").StructureAnyDefinitionTarget, ValidatorErrorMap>}
 */
export function validateStructureAnyDefinitionTarget(value: import("../common/types.js").StructureAnyDefinitionTarget | any): Either<import("../common/types.js").StructureAnyDefinitionTarget, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureAnyOfDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureAnyOfDefinition, ValidatorErrorMap>}
 */
export function validateStructureAnyOfDefinition(value: import("../common/types.js").StructureAnyOfDefinitionInput | any): Either<import("../common/types.js").StructureAnyOfDefinition, ValidatorErrorMap>;
/**
 * All type definitions that can be used inside other types, like object keys.
 *
 * @param {import("../common/types.js").StructureTypeSystemDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureTypeSystemDefinition, ValidatorErrorMap>}
 */
export function validateStructureTypeSystemDefinition(value: import("../common/types.js").StructureTypeSystemDefinitionInput | any): Either<import("../common/types.js").StructureTypeSystemDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureArrayDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureArrayDefinition, ValidatorErrorMap>}
 */
export function validateStructureArrayDefinition(value: import("../common/types.js").StructureArrayDefinitionInput | any): Either<import("../common/types.js").StructureArrayDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureBooleanDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureBooleanDefinition, ValidatorErrorMap>}
 */
export function validateStructureBooleanDefinition(value: import("../common/types.js").StructureBooleanDefinitionInput | any): Either<import("../common/types.js").StructureBooleanDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureCrudDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureCrudDefinition, ValidatorErrorMap>}
 */
export function validateStructureCrudDefinition(value: import("../common/types.js").StructureCrudDefinitionInput | any): Either<import("../common/types.js").StructureCrudDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureReferenceDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureReferenceDefinition, ValidatorErrorMap>}
 */
export function validateStructureReferenceDefinition(value: import("../common/types.js").StructureReferenceDefinitionInput | any): Either<import("../common/types.js").StructureReferenceDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureNamePart|any} value
 * @returns {Either<import("../common/types.js").StructureNamePart, ValidatorErrorMap>}
 */
export function validateStructureNamePart(value: import("../common/types.js").StructureNamePart | any): Either<import("../common/types.js").StructureNamePart, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureDateDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureDateDefinition, ValidatorErrorMap>}
 */
export function validateStructureDateDefinition(value: import("../common/types.js").StructureDateDefinitionInput | any): Either<import("../common/types.js").StructureDateDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureExtendDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureExtendDefinition, ValidatorErrorMap>}
 */
export function validateStructureExtendDefinition(value: import("../common/types.js").StructureExtendDefinitionInput | any): Either<import("../common/types.js").StructureExtendDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureRelationDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureRelationDefinition, ValidatorErrorMap>}
 */
export function validateStructureRelationDefinition(value: import("../common/types.js").StructureRelationDefinitionInput | any): Either<import("../common/types.js").StructureRelationDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureFileDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureFileDefinition, ValidatorErrorMap>}
 */
export function validateStructureFileDefinition(value: import("../common/types.js").StructureFileDefinitionInput | any): Either<import("../common/types.js").StructureFileDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureGenericDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureGenericDefinition, ValidatorErrorMap>}
 */
export function validateStructureGenericDefinition(value: import("../common/types.js").StructureGenericDefinitionInput | any): Either<import("../common/types.js").StructureGenericDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureNumberDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureNumberDefinition, ValidatorErrorMap>}
 */
export function validateStructureNumberDefinition(value: import("../common/types.js").StructureNumberDefinitionInput | any): Either<import("../common/types.js").StructureNumberDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureObjectDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureObjectDefinition, ValidatorErrorMap>}
 */
export function validateStructureObjectDefinition(value: import("../common/types.js").StructureObjectDefinitionInput | any): Either<import("../common/types.js").StructureObjectDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureOmitDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureOmitDefinition, ValidatorErrorMap>}
 */
export function validateStructureOmitDefinition(value: import("../common/types.js").StructureOmitDefinitionInput | any): Either<import("../common/types.js").StructureOmitDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructurePickDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructurePickDefinition, ValidatorErrorMap>}
 */
export function validateStructurePickDefinition(value: import("../common/types.js").StructurePickDefinitionInput | any): Either<import("../common/types.js").StructurePickDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureStringDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureStringDefinition, ValidatorErrorMap>}
 */
export function validateStructureStringDefinition(value: import("../common/types.js").StructureStringDefinitionInput | any): Either<import("../common/types.js").StructureStringDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureUuidDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureUuidDefinition, ValidatorErrorMap>}
 */
export function validateStructureUuidDefinition(value: import("../common/types.js").StructureUuidDefinitionInput | any): Either<import("../common/types.js").StructureUuidDefinition, ValidatorErrorMap>;
/**
 * Select the targets and generators to be used when generating. See {@link https://compasjs.com/generators/targets.html} for more information.
 *
 * @param {import("../common/types.js").StructureGenerateOptionsInput|any} value
 * @returns {Either<import("../common/types.js").StructureGenerateOptions, ValidatorErrorMap>}
 */
export function validateStructureGenerateOptions(value: import("../common/types.js").StructureGenerateOptionsInput | any): Either<import("../common/types.js").StructureGenerateOptions, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureNamePartOptional|any} value
 * @returns {Either<import("../common/types.js").StructureNamePartOptional, ValidatorErrorMap>}
 */
export function validateStructureNamePartOptional(value: import("../common/types.js").StructureNamePartOptional | any): Either<import("../common/types.js").StructureNamePartOptional, ValidatorErrorMap>;
/**
 * This contains all types that can be added top level to the structure.
 *
 * @param {import("../common/types.js").StructureNamedTypeDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureNamedTypeDefinition, ValidatorErrorMap>}
 */
export function validateStructureNamedTypeDefinition(value: import("../common/types.js").StructureNamedTypeDefinitionInput | any): Either<import("../common/types.js").StructureNamedTypeDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureRouteDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureRouteDefinition, ValidatorErrorMap>}
 */
export function validateStructureRouteDefinition(value: import("../common/types.js").StructureRouteDefinitionInput | any): Either<import("../common/types.js").StructureRouteDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureRouteInvalidationDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureRouteInvalidationDefinition, ValidatorErrorMap>}
 */
export function validateStructureRouteInvalidationDefinition(value: import("../common/types.js").StructureRouteInvalidationDefinitionInput | any): Either<import("../common/types.js").StructureRouteInvalidationDefinition, ValidatorErrorMap>;
/**
 * @param {import("../common/types.js").StructureStructureInput|any} value
 * @returns {Either<import("../common/types.js").StructureStructure, ValidatorErrorMap>}
 */
export function validateStructureStructure(value: import("../common/types.js").StructureStructureInput | any): Either<import("../common/types.js").StructureStructure, ValidatorErrorMap>;
/**
 * This contains all known type definitions.
 *
 * @param {import("../common/types.js").StructureTypeDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureTypeDefinition, ValidatorErrorMap>}
 */
export function validateStructureTypeDefinition(value: import("../common/types.js").StructureTypeDefinitionInput | any): Either<import("../common/types.js").StructureTypeDefinition, ValidatorErrorMap>;
export type Either<T, E> = {
    value: T;
    error?: never;
} | {
    value?: never;
    error: E;
};
export type ValidatorErrorMap = Record<string, any | undefined>;
