/**
 * Get a list of CRUD objects in the structure
 *
 * @param {import("../generate.js").GenerateContext} generateContext
 * @returns {Array<(import("../../types/advanced-types.d.ts").NamedType<import("../generated/common/types.d.ts").StructureCrudDefinition>)>}
 */
export function structureCrud(generateContext: import("../generate.js").GenerateContext): Array<(import("../../types/advanced-types.d.ts").NamedType<import("../generated/common/types.d.ts").StructureCrudDefinition>)>;
/**
 * Call the route specific functions that are enabled on the CRUD object.
 *
 * @template {Array<any>} X
 * @param {import("../../types/advanced-types.d.ts").NamedType<import("../generated/common/types.d.ts").StructureCrudDefinition>} crud
 * @param {{
 *   listRoute: (...X) => void,
 *   singleRoute: (...X) => void,
 *   createRoute: (...X) => void,
 *   updateRoute: (...X) => void,
 *   deleteRoute: (...X) => void,
 * }} functions
 * @param {X} args
 */
export function crudRouteSwitch<X extends Array<any>>(crud: import("../../types/advanced-types.d.ts").NamedType<import("../generated/common/types.d.ts").StructureCrudDefinition>, functions: {
    listRoute: (...X: any) => void;
    singleRoute: (...X: any) => void;
    createRoute: (...X: any) => void;
    updateRoute: (...X: any) => void;
    deleteRoute: (...X: any) => void;
}, args: X): void;
