// Generated by @compas/code-gen

/**
 * @template T, E
 * @typedef {{ value: T, error?: never}|{ value?: never, error: E }} Either
 */

/**
 * @typedef {Record<string, any|undefined>} ValidatorErrorMap
 */

const isRecord = (v) => !!v && typeof v === "object" && !Array.isArray(v);

/**
 * @param {import("../common/types.js").StructureAnyDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureAnyDefinition, ValidatorErrorMap>}
 */
export function validateStructureAnyDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        targets: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "any") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["any"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { allowNull: undefined };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            errorMap[`$.validator.allowNull`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["targets"] === null || value["targets"] === undefined) {
        result["targets"] = undefined;
      } else {
        if (!isRecord(value["targets"])) {
          errorMap[`$.targets`] = {
            key: "validator.generic",
          };
        } else {
          result["targets"] = {};
          for (const genericKeyInput9 of Object.keys(value["targets"])) {
            /** @type {any} */
            let genericKeyResult10 = undefined;
            /** @type {ValidatorErrorMap} */
            const genericKeyErrorMap11 = {};
            if (genericKeyInput9 === null || genericKeyInput9 === undefined) {
              genericKeyErrorMap11[`$`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult12 =
                validateStructureAnyDefinitionTarget(genericKeyInput9);

              if (refResult12.error) {
                for (const errorKey of Object.keys(refResult12.error)) {
                  genericKeyErrorMap11[`$${errorKey.substring(1)}`] =
                    refResult12.error[errorKey];
                }
              }
              genericKeyResult10 = refResult12.value;
            }
            if (Object.keys(genericKeyErrorMap11).length !== 0) {
              if (errorMap[`$.targets`]) {
                errorMap[`$.targets`].inputs.push({
                  key: genericKeyInput9,
                  errors: genericKeyErrorMap11,
                });
              } else {
                errorMap[`$.targets`] = {
                  key: "validator.generic",
                  inputs: [
                    { key: genericKeyInput9, errors: genericKeyErrorMap11 },
                  ],
                };
              }
            } else {
              if (
                value["targets"][genericKeyResult10] === null ||
                value["targets"][genericKeyResult10] === undefined
              ) {
                errorMap[`$.targets.${genericKeyResult10}`] = {
                  key: "validator.undefined",
                };
              } else {
                if (!isRecord(value["targets"][genericKeyResult10])) {
                  errorMap[`$.targets.${genericKeyResult10}`] = {
                    key: "validator.object",
                    value: value["targets"][genericKeyResult10],
                    foundType: typeof value["targets"][genericKeyResult10],
                  };
                } else {
                  /** @type {Set<string>} */
                  const knownKeys12 = new Set([
                    "validatorInputType",
                    "validatorOutputType",
                    "validatorExpression",
                    "validatorImport",
                  ]);
                  for (const key of Object.keys(
                    value["targets"][genericKeyResult10],
                  )) {
                    if (
                      !knownKeys12.has(key) &&
                      value["targets"][genericKeyResult10][key] !== null &&
                      value["targets"][genericKeyResult10][key] !== undefined
                    ) {
                      const expectedKeys = [...knownKeys12];
                      const foundKeys = Object.keys(
                        value["targets"][genericKeyResult10],
                      );
                      const unknownKeys = foundKeys.filter(
                        (it) => !knownKeys12.has(it),
                      );
                      errorMap[`$.targets.${genericKeyResult10}`] = {
                        key: "validator.keys",
                        unknownKeys,
                        expectedKeys,
                        foundKeys,
                      };
                      break;
                    }
                  }
                  result["targets"][genericKeyResult10] = {
                    validatorInputType: undefined,
                    validatorOutputType: undefined,
                    validatorExpression: undefined,
                    validatorImport: undefined,
                  };

                  if (
                    value["targets"][genericKeyResult10][
                      "validatorInputType"
                    ] === null ||
                    value["targets"][genericKeyResult10][
                      "validatorInputType"
                    ] === undefined
                  ) {
                    errorMap[
                      `$.targets.${genericKeyResult10}.validatorInputType`
                    ] = {
                      key: "validator.undefined",
                    };
                  } else {
                    /** @type {string} */
                    const convertedString13 =
                      value["targets"][genericKeyResult10][
                        "validatorInputType"
                      ];
                    if (typeof convertedString13 !== "string") {
                      errorMap[
                        `$.targets.${genericKeyResult10}.validatorInputType`
                      ] = {
                        key: "validator.string",
                      };
                    } else {
                      if (convertedString13.length < 1) {
                        errorMap[
                          `$.targets.${genericKeyResult10}.validatorInputType`
                        ] = {
                          key: "validator.length",
                          minLength: 1,
                        };
                      } else {
                        result["targets"][genericKeyResult10][
                          "validatorInputType"
                        ] = convertedString13;
                      }
                    }
                  }
                  if (
                    value["targets"][genericKeyResult10][
                      "validatorOutputType"
                    ] === null ||
                    value["targets"][genericKeyResult10][
                      "validatorOutputType"
                    ] === undefined
                  ) {
                    errorMap[
                      `$.targets.${genericKeyResult10}.validatorOutputType`
                    ] = {
                      key: "validator.undefined",
                    };
                  } else {
                    /** @type {string} */
                    const convertedString14 =
                      value["targets"][genericKeyResult10][
                        "validatorOutputType"
                      ];
                    if (typeof convertedString14 !== "string") {
                      errorMap[
                        `$.targets.${genericKeyResult10}.validatorOutputType`
                      ] = {
                        key: "validator.string",
                      };
                    } else {
                      if (convertedString14.length < 1) {
                        errorMap[
                          `$.targets.${genericKeyResult10}.validatorOutputType`
                        ] = {
                          key: "validator.length",
                          minLength: 1,
                        };
                      } else {
                        result["targets"][genericKeyResult10][
                          "validatorOutputType"
                        ] = convertedString14;
                      }
                    }
                  }
                  if (
                    value["targets"][genericKeyResult10][
                      "validatorExpression"
                    ] === null ||
                    value["targets"][genericKeyResult10][
                      "validatorExpression"
                    ] === undefined
                  ) {
                    result["targets"][genericKeyResult10][
                      "validatorExpression"
                    ] = undefined;
                  } else {
                    /** @type {string} */
                    const convertedString15 =
                      value["targets"][genericKeyResult10][
                        "validatorExpression"
                      ];
                    if (typeof convertedString15 !== "string") {
                      errorMap[
                        `$.targets.${genericKeyResult10}.validatorExpression`
                      ] = {
                        key: "validator.string",
                      };
                    } else {
                      if (convertedString15.length === 0) {
                        result["targets"][genericKeyResult10][
                          "validatorExpression"
                        ] = undefined;
                      } else {
                        if (convertedString15.length < 1) {
                          errorMap[
                            `$.targets.${genericKeyResult10}.validatorExpression`
                          ] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          result["targets"][genericKeyResult10][
                            "validatorExpression"
                          ] = convertedString15;
                        }
                      }
                    }
                  }
                  if (
                    value["targets"][genericKeyResult10]["validatorImport"] ===
                      null ||
                    value["targets"][genericKeyResult10]["validatorImport"] ===
                      undefined
                  ) {
                    result["targets"][genericKeyResult10]["validatorImport"] =
                      undefined;
                  } else {
                    /** @type {string} */
                    const convertedString16 =
                      value["targets"][genericKeyResult10]["validatorImport"];
                    if (typeof convertedString16 !== "string") {
                      errorMap[
                        `$.targets.${genericKeyResult10}.validatorImport`
                      ] = {
                        key: "validator.string",
                      };
                    } else {
                      if (convertedString16.length === 0) {
                        result["targets"][genericKeyResult10][
                          "validatorImport"
                        ] = undefined;
                      } else {
                        if (convertedString16.length < 1) {
                          errorMap[
                            `$.targets.${genericKeyResult10}.validatorImport`
                          ] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          result["targets"][genericKeyResult10][
                            "validatorImport"
                          ] = convertedString16;
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureAnyDefinitionTarget|any} value
 * @returns {Either<import("../common/types.js").StructureAnyDefinitionTarget, ValidatorErrorMap>}
 */
export function validateStructureAnyDefinitionTarget(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    /** @type {string} */
    const convertedString0 = value;
    if (typeof convertedString0 !== "string") {
      errorMap[`$`] = {
        key: "validator.string",
      };
    } else {
      if (convertedString0.length < 1) {
        errorMap[`$`] = {
          key: "validator.length",
          minLength: 1,
        };
      } else if (
        convertedString0 !== "js" &&
        convertedString0 !== "ts" &&
        convertedString0 !== "jsKoaReceive" &&
        convertedString0 !== "tsKoaReceive" &&
        convertedString0 !== "jsKoaSend" &&
        convertedString0 !== "tsKoaSend" &&
        convertedString0 !== "jsPostgres" &&
        convertedString0 !== "tsPostgres" &&
        convertedString0 !== "jsAxios" &&
        convertedString0 !== "tsAxios" &&
        convertedString0 !== "jsAxiosNode" &&
        convertedString0 !== "tsAxiosBrowser" &&
        convertedString0 !== "tsAxiosReactNative" &&
        convertedString0 !== "jsFetch" &&
        convertedString0 !== "tsFetch" &&
        convertedString0 !== "jsFetchNode" &&
        convertedString0 !== "tsFetchBrowser" &&
        convertedString0 !== "tsFetchReactNative"
      ) {
        errorMap[`$`] = {
          key: "validator.oneOf",
          allowedValues: [
            "js",
            "ts",
            "jsKoaReceive",
            "tsKoaReceive",
            "jsKoaSend",
            "tsKoaSend",
            "jsPostgres",
            "tsPostgres",
            "jsAxios",
            "tsAxios",
            "jsAxiosNode",
            "tsAxiosBrowser",
            "tsAxiosReactNative",
            "jsFetch",
            "tsFetch",
            "jsFetchNode",
            "tsFetchBrowser",
            "tsFetchReactNative",
          ],
          foundValue: convertedString0,
        };
      } else {
        result = convertedString0;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureAnyOfDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureAnyOfDefinition, ValidatorErrorMap>}
 */
export function validateStructureAnyOfDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        values: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "anyOf") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["anyOf"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        result["validator"] = {};
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { discriminant: undefined };

          if (
            value["validator"]["discriminant"] === null ||
            value["validator"]["discriminant"] === undefined
          ) {
            result["validator"]["discriminant"] = undefined;
          } else {
            /** @type {string} */
            const convertedString9 = value["validator"]["discriminant"];
            if (typeof convertedString9 !== "string") {
              errorMap[`$.validator.discriminant`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString9.length === 0) {
                result["validator"]["discriminant"] = undefined;
              } else {
                if (convertedString9.length < 1) {
                  errorMap[`$.validator.discriminant`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  result["validator"]["discriminant"] = convertedString9;
                }
              }
            }
          }
        }
      }
      if (value["values"] === null || value["values"] === undefined) {
        errorMap[`$.values`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap10 = {};
        /** @type {Array<any>} */
        const intermediateResult10 = [];
        /** @type {any | Array<any>} */
        const intermediateValue10 = value["values"];

        if (!Array.isArray(intermediateValue10)) {
          errorMap[`$.values`] = {
            key: "validator.array",
            value: intermediateValue10,
          };
        } else {
          if (intermediateValue10.length < 1) {
            errorMap[`$.values`] = {
              key: "validator.length",
              minLength: 1,
              foundLength: intermediateValue10.length,
            };
          }
          result["values"] = [];
          for (let i10 = 0; i10 < intermediateValue10.length; ++i10) {
            if (
              intermediateValue10[i10] === null ||
              intermediateValue10[i10] === undefined
            ) {
              intermediateErrorMap10[`$.${i10}`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult10 = validateStructureTypeSystemDefinition(
                intermediateValue10[i10],
              );

              if (refResult10.error) {
                for (const errorKey of Object.keys(refResult10.error)) {
                  intermediateErrorMap10[`$.${i10}${errorKey.substring(1)}`] =
                    refResult10.error[errorKey];
                }
              }
              intermediateResult10[i10] = refResult10.value;
            }
          }
        }
        if (Object.keys(intermediateErrorMap10).length) {
          for (const errorKey of Object.keys(intermediateErrorMap10)) {
            errorMap[`$.values${errorKey.substring(1)}`] =
              intermediateErrorMap10[errorKey];
          }
        } else {
          result["values"] = intermediateResult10;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * All type definitions that can be used inside other types, like object keys.
 *
 * @param {import("../common/types.js").StructureTypeSystemDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureTypeSystemDefinition, ValidatorErrorMap>}
 */
export function validateStructureTypeSystemDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "any"
      ) {
        const refResult0 = validateStructureAnyDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "anyOf"
      ) {
        const refResult0 = validateStructureAnyOfDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "array"
      ) {
        const refResult0 = validateStructureArrayDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "boolean"
      ) {
        const refResult0 = validateStructureBooleanDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "crud"
      ) {
        const refResult0 = validateStructureCrudDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "date"
      ) {
        const refResult0 = validateStructureDateDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "extend"
      ) {
        const refResult0 = validateStructureExtendDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "file"
      ) {
        const refResult0 = validateStructureFileDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "generic"
      ) {
        const refResult0 = validateStructureGenericDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "number"
      ) {
        const refResult0 = validateStructureNumberDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "object"
      ) {
        const refResult0 = validateStructureObjectDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "omit"
      ) {
        const refResult0 = validateStructureOmitDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "pick"
      ) {
        const refResult0 = validateStructurePickDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "reference"
      ) {
        const refResult0 = validateStructureReferenceDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "string"
      ) {
        const refResult0 = validateStructureStringDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "uuid"
      ) {
        const refResult0 = validateStructureUuidDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else {
        errorMap[`$`] = {
          key: "validator.anyOf",
          discriminant: "type",
          foundValue: value.type,
          allowedValues: [
            "any",
            "anyOf",
            "array",
            "boolean",
            "crud",
            "date",
            "extend",
            "file",
            "generic",
            "number",
            "object",
            "omit",
            "pick",
            "reference",
            "string",
            "uuid",
          ],
        };
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureArrayDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureArrayDefinition, ValidatorErrorMap>}
 */
export function validateStructureArrayDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        values: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "array") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["array"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {
            convert: undefined,
            min: undefined,
            max: undefined,
          };

          if (
            value["validator"]["convert"] === null ||
            value["validator"]["convert"] === undefined
          ) {
            errorMap[`$.validator.convert`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["convert"] === true ||
              value["validator"]["convert"] === "true" ||
              value["validator"]["convert"] === 1 ||
              value["validator"]["convert"] === "1"
            ) {
              result["validator"]["convert"] = true;
            } else if (
              value["validator"]["convert"] === false ||
              value["validator"]["convert"] === "false" ||
              value["validator"]["convert"] === 0 ||
              value["validator"]["convert"] === "0"
            ) {
              result["validator"]["convert"] = false;
            } else {
              errorMap[`$.validator.convert`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["min"] === null ||
            value["validator"]["min"] === undefined
          ) {
            result["validator"]["min"] = undefined;
          } else {
            let convertedNumber10 = value["validator"]["min"];
            if (
              typeof convertedNumber10 !== "number" &&
              typeof convertedNumber10 === "string"
            ) {
              convertedNumber10 = Number(convertedNumber10);
            }
            if (
              typeof convertedNumber10 !== "number" ||
              isNaN(convertedNumber10) ||
              !isFinite(convertedNumber10) ||
              !Number.isInteger(convertedNumber10)
            ) {
              errorMap[`$.validator.min`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber10 < 0) {
              errorMap[`$.validator.min`] = {
                key: "validator.range",
                minValue: 0,
              };
            } else if (convertedNumber10 > 9007199254740991) {
              errorMap[`$.validator.min`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              result["validator"]["min"] = convertedNumber10;
            }
          }
          if (
            value["validator"]["max"] === null ||
            value["validator"]["max"] === undefined
          ) {
            result["validator"]["max"] = undefined;
          } else {
            let convertedNumber11 = value["validator"]["max"];
            if (
              typeof convertedNumber11 !== "number" &&
              typeof convertedNumber11 === "string"
            ) {
              convertedNumber11 = Number(convertedNumber11);
            }
            if (
              typeof convertedNumber11 !== "number" ||
              isNaN(convertedNumber11) ||
              !isFinite(convertedNumber11) ||
              !Number.isInteger(convertedNumber11)
            ) {
              errorMap[`$.validator.max`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber11 < 0) {
              errorMap[`$.validator.max`] = {
                key: "validator.range",
                minValue: 0,
              };
            } else if (convertedNumber11 > 9007199254740991) {
              errorMap[`$.validator.max`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              result["validator"]["max"] = convertedNumber11;
            }
          }
        }
      }
      if (value["values"] === null || value["values"] === undefined) {
        errorMap[`$.values`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult9 = validateStructureTypeSystemDefinition(
          value["values"],
        );

        if (refResult9.error) {
          for (const errorKey of Object.keys(refResult9.error)) {
            errorMap[`$.values${errorKey.substring(1)}`] =
              refResult9.error[errorKey];
          }
        }
        result["values"] = refResult9.value;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureBooleanDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureBooleanDefinition, ValidatorErrorMap>}
 */
export function validateStructureBooleanDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        oneOf: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "boolean") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["boolean"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { allowNull: undefined };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["oneOf"] === null || value["oneOf"] === undefined) {
        result["oneOf"] = undefined;
      } else {
        if (
          value["oneOf"] === true ||
          value["oneOf"] === "true" ||
          value["oneOf"] === 1 ||
          value["oneOf"] === "1"
        ) {
          result["oneOf"] = true;
        } else if (
          value["oneOf"] === false ||
          value["oneOf"] === "false" ||
          value["oneOf"] === 0 ||
          value["oneOf"] === "0"
        ) {
          result["oneOf"] = false;
        } else {
          errorMap[`$.oneOf`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureCrudDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureCrudDefinition, ValidatorErrorMap>}
 */
export function validateStructureCrudDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        basePath: undefined,
        entity: undefined,
        fromParent: undefined,
        routeOptions: undefined,
        fieldOptions: undefined,
        inlineRelations: undefined,
        nestedRelations: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "crud") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["crud"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        result["validator"] = {};
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {};
        }
      }
      if (value["basePath"] === null || value["basePath"] === undefined) {
        result["basePath"] = undefined;
      } else {
        /** @type {string} */
        const convertedString9 = value["basePath"];
        if (typeof convertedString9 !== "string") {
          errorMap[`$.basePath`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString9.length === 0) {
            result["basePath"] = undefined;
          } else {
            if (convertedString9.length < 1) {
              errorMap[`$.basePath`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["basePath"] = convertedString9;
            }
          }
        }
      }
      if (value["entity"] === null || value["entity"] === undefined) {
        result["entity"] = undefined;
      } else {
        const refResult10 = validateStructureReferenceDefinition(
          value["entity"],
        );

        if (refResult10.error) {
          for (const errorKey of Object.keys(refResult10.error)) {
            errorMap[`$.entity${errorKey.substring(1)}`] =
              refResult10.error[errorKey];
          }
        }
        result["entity"] = refResult10.value;
      }
      if (value["fromParent"] === null || value["fromParent"] === undefined) {
        result["fromParent"] = undefined;
      } else {
        if (!isRecord(value["fromParent"])) {
          errorMap[`$.fromParent`] = {
            key: "validator.object",
            value: value["fromParent"],
            foundType: typeof value["fromParent"],
          };
        } else {
          result["fromParent"] = { field: undefined, options: undefined };

          if (
            value["fromParent"]["field"] === null ||
            value["fromParent"]["field"] === undefined
          ) {
            errorMap[`$.fromParent.field`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString12 = value["fromParent"]["field"];
            if (typeof convertedString12 !== "string") {
              errorMap[`$.fromParent.field`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString12.length < 1) {
                errorMap[`$.fromParent.field`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                result["fromParent"]["field"] = convertedString12;
              }
            }
          }
          if (
            value["fromParent"]["options"] === null ||
            value["fromParent"]["options"] === undefined
          ) {
            result["fromParent"]["options"] = undefined;
          } else {
            if (!isRecord(value["fromParent"]["options"])) {
              errorMap[`$.fromParent.options`] = {
                key: "validator.object",
                value: value["fromParent"]["options"],
                foundType: typeof value["fromParent"]["options"],
              };
            } else {
              result["fromParent"]["options"] = { name: undefined };

              if (
                value["fromParent"]["options"]["name"] === null ||
                value["fromParent"]["options"]["name"] === undefined
              ) {
                result["fromParent"]["options"]["name"] = undefined;
              } else {
                /** @type {string} */
                const convertedString14 =
                  value["fromParent"]["options"]["name"];
                if (typeof convertedString14 !== "string") {
                  errorMap[`$.fromParent.options.name`] = {
                    key: "validator.string",
                  };
                } else {
                  if (convertedString14.length === 0) {
                    result["fromParent"]["options"]["name"] = undefined;
                  } else {
                    if (convertedString14.length < 1) {
                      errorMap[`$.fromParent.options.name`] = {
                        key: "validator.length",
                        minLength: 1,
                      };
                    } else {
                      result["fromParent"]["options"]["name"] =
                        convertedString14;
                    }
                  }
                }
              }
            }
          }
        }
      }
      if (
        value["routeOptions"] === null ||
        value["routeOptions"] === undefined
      ) {
        errorMap[`$.routeOptions`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["routeOptions"])) {
          errorMap[`$.routeOptions`] = {
            key: "validator.object",
            value: value["routeOptions"],
            foundType: typeof value["routeOptions"],
          };
        } else {
          result["routeOptions"] = {
            listRoute: undefined,
            singleRoute: undefined,
            createRoute: undefined,
            updateRoute: undefined,
            deleteRoute: undefined,
          };

          if (
            value["routeOptions"]["listRoute"] === null ||
            value["routeOptions"]["listRoute"] === undefined
          ) {
            result["routeOptions"]["listRoute"] = undefined;
          } else {
            if (
              value["routeOptions"]["listRoute"] === true ||
              value["routeOptions"]["listRoute"] === "true" ||
              value["routeOptions"]["listRoute"] === 1 ||
              value["routeOptions"]["listRoute"] === "1"
            ) {
              result["routeOptions"]["listRoute"] = true;
            } else if (
              value["routeOptions"]["listRoute"] === false ||
              value["routeOptions"]["listRoute"] === "false" ||
              value["routeOptions"]["listRoute"] === 0 ||
              value["routeOptions"]["listRoute"] === "0"
            ) {
              result["routeOptions"]["listRoute"] = false;
            } else {
              errorMap[`$.routeOptions.listRoute`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["routeOptions"]["singleRoute"] === null ||
            value["routeOptions"]["singleRoute"] === undefined
          ) {
            result["routeOptions"]["singleRoute"] = undefined;
          } else {
            if (
              value["routeOptions"]["singleRoute"] === true ||
              value["routeOptions"]["singleRoute"] === "true" ||
              value["routeOptions"]["singleRoute"] === 1 ||
              value["routeOptions"]["singleRoute"] === "1"
            ) {
              result["routeOptions"]["singleRoute"] = true;
            } else if (
              value["routeOptions"]["singleRoute"] === false ||
              value["routeOptions"]["singleRoute"] === "false" ||
              value["routeOptions"]["singleRoute"] === 0 ||
              value["routeOptions"]["singleRoute"] === "0"
            ) {
              result["routeOptions"]["singleRoute"] = false;
            } else {
              errorMap[`$.routeOptions.singleRoute`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["routeOptions"]["createRoute"] === null ||
            value["routeOptions"]["createRoute"] === undefined
          ) {
            result["routeOptions"]["createRoute"] = undefined;
          } else {
            if (
              value["routeOptions"]["createRoute"] === true ||
              value["routeOptions"]["createRoute"] === "true" ||
              value["routeOptions"]["createRoute"] === 1 ||
              value["routeOptions"]["createRoute"] === "1"
            ) {
              result["routeOptions"]["createRoute"] = true;
            } else if (
              value["routeOptions"]["createRoute"] === false ||
              value["routeOptions"]["createRoute"] === "false" ||
              value["routeOptions"]["createRoute"] === 0 ||
              value["routeOptions"]["createRoute"] === "0"
            ) {
              result["routeOptions"]["createRoute"] = false;
            } else {
              errorMap[`$.routeOptions.createRoute`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["routeOptions"]["updateRoute"] === null ||
            value["routeOptions"]["updateRoute"] === undefined
          ) {
            result["routeOptions"]["updateRoute"] = undefined;
          } else {
            if (
              value["routeOptions"]["updateRoute"] === true ||
              value["routeOptions"]["updateRoute"] === "true" ||
              value["routeOptions"]["updateRoute"] === 1 ||
              value["routeOptions"]["updateRoute"] === "1"
            ) {
              result["routeOptions"]["updateRoute"] = true;
            } else if (
              value["routeOptions"]["updateRoute"] === false ||
              value["routeOptions"]["updateRoute"] === "false" ||
              value["routeOptions"]["updateRoute"] === 0 ||
              value["routeOptions"]["updateRoute"] === "0"
            ) {
              result["routeOptions"]["updateRoute"] = false;
            } else {
              errorMap[`$.routeOptions.updateRoute`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["routeOptions"]["deleteRoute"] === null ||
            value["routeOptions"]["deleteRoute"] === undefined
          ) {
            result["routeOptions"]["deleteRoute"] = undefined;
          } else {
            if (
              value["routeOptions"]["deleteRoute"] === true ||
              value["routeOptions"]["deleteRoute"] === "true" ||
              value["routeOptions"]["deleteRoute"] === 1 ||
              value["routeOptions"]["deleteRoute"] === "1"
            ) {
              result["routeOptions"]["deleteRoute"] = true;
            } else if (
              value["routeOptions"]["deleteRoute"] === false ||
              value["routeOptions"]["deleteRoute"] === "false" ||
              value["routeOptions"]["deleteRoute"] === 0 ||
              value["routeOptions"]["deleteRoute"] === "0"
            ) {
              result["routeOptions"]["deleteRoute"] = false;
            } else {
              errorMap[`$.routeOptions.deleteRoute`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (
        value["fieldOptions"] === null ||
        value["fieldOptions"] === undefined
      ) {
        errorMap[`$.fieldOptions`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["fieldOptions"])) {
          errorMap[`$.fieldOptions`] = {
            key: "validator.object",
            value: value["fieldOptions"],
            foundType: typeof value["fieldOptions"],
          };
        } else {
          result["fieldOptions"] = {
            readable: undefined,
            readableType: undefined,
            writable: undefined,
          };

          if (
            value["fieldOptions"]["readable"] === null ||
            value["fieldOptions"]["readable"] === undefined
          ) {
            result["fieldOptions"]["readable"] = undefined;
          } else {
            if (!isRecord(value["fieldOptions"]["readable"])) {
              errorMap[`$.fieldOptions.readable`] = {
                key: "validator.object",
                value: value["fieldOptions"]["readable"],
                foundType: typeof value["fieldOptions"]["readable"],
              };
            } else {
              result["fieldOptions"]["readable"] = {
                $omit: undefined,
                $pick: undefined,
              };

              if (
                value["fieldOptions"]["readable"]["$omit"] === null ||
                value["fieldOptions"]["readable"]["$omit"] === undefined
              ) {
                result["fieldOptions"]["readable"]["$omit"] = undefined;
              } else {
                /** @type {ValidatorErrorMap} */
                const intermediateErrorMap16 = {};
                /** @type {Array<any>} */
                const intermediateResult16 = [];
                /** @type {any | Array<any>} */
                const intermediateValue16 =
                  value["fieldOptions"]["readable"]["$omit"];

                if (!Array.isArray(intermediateValue16)) {
                  errorMap[`$.fieldOptions.readable.$omit`] = {
                    key: "validator.array",
                    value: intermediateValue16,
                  };
                } else {
                  result["fieldOptions"]["readable"]["$omit"] = [];
                  for (let i16 = 0; i16 < intermediateValue16.length; ++i16) {
                    if (
                      intermediateValue16[i16] === null ||
                      intermediateValue16[i16] === undefined
                    ) {
                      intermediateErrorMap16[`$.${i16}`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString16 = intermediateValue16[i16];
                      if (typeof convertedString16 !== "string") {
                        intermediateErrorMap16[`$.${i16}`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString16.length < 1) {
                          intermediateErrorMap16[`$.${i16}`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          intermediateResult16[i16] = convertedString16;
                        }
                      }
                    }
                  }
                }
                if (Object.keys(intermediateErrorMap16).length) {
                  for (const errorKey of Object.keys(intermediateErrorMap16)) {
                    errorMap[
                      `$.fieldOptions.readable.$omit${errorKey.substring(1)}`
                    ] = intermediateErrorMap16[errorKey];
                  }
                } else {
                  result["fieldOptions"]["readable"]["$omit"] =
                    intermediateResult16;
                }
              }
              if (
                value["fieldOptions"]["readable"]["$pick"] === null ||
                value["fieldOptions"]["readable"]["$pick"] === undefined
              ) {
                result["fieldOptions"]["readable"]["$pick"] = undefined;
              } else {
                /** @type {ValidatorErrorMap} */
                const intermediateErrorMap17 = {};
                /** @type {Array<any>} */
                const intermediateResult17 = [];
                /** @type {any | Array<any>} */
                const intermediateValue17 =
                  value["fieldOptions"]["readable"]["$pick"];

                if (!Array.isArray(intermediateValue17)) {
                  errorMap[`$.fieldOptions.readable.$pick`] = {
                    key: "validator.array",
                    value: intermediateValue17,
                  };
                } else {
                  result["fieldOptions"]["readable"]["$pick"] = [];
                  for (let i17 = 0; i17 < intermediateValue17.length; ++i17) {
                    if (
                      intermediateValue17[i17] === null ||
                      intermediateValue17[i17] === undefined
                    ) {
                      intermediateErrorMap17[`$.${i17}`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString17 = intermediateValue17[i17];
                      if (typeof convertedString17 !== "string") {
                        intermediateErrorMap17[`$.${i17}`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString17.length < 1) {
                          intermediateErrorMap17[`$.${i17}`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          intermediateResult17[i17] = convertedString17;
                        }
                      }
                    }
                  }
                }
                if (Object.keys(intermediateErrorMap17).length) {
                  for (const errorKey of Object.keys(intermediateErrorMap17)) {
                    errorMap[
                      `$.fieldOptions.readable.$pick${errorKey.substring(1)}`
                    ] = intermediateErrorMap17[errorKey];
                  }
                } else {
                  result["fieldOptions"]["readable"]["$pick"] =
                    intermediateResult17;
                }
              }
            }
          }
          if (
            value["fieldOptions"]["readableType"] === null ||
            value["fieldOptions"]["readableType"] === undefined
          ) {
            result["fieldOptions"]["readableType"] = undefined;
          } else {
            const refResult15 = validateStructureReferenceDefinition(
              value["fieldOptions"]["readableType"],
            );

            if (refResult15.error) {
              for (const errorKey of Object.keys(refResult15.error)) {
                errorMap[
                  `$.fieldOptions.readableType${errorKey.substring(1)}`
                ] = refResult15.error[errorKey];
              }
            }
            result["fieldOptions"]["readableType"] = refResult15.value;
          }
          if (
            value["fieldOptions"]["writable"] === null ||
            value["fieldOptions"]["writable"] === undefined
          ) {
            result["fieldOptions"]["writable"] = undefined;
          } else {
            if (!isRecord(value["fieldOptions"]["writable"])) {
              errorMap[`$.fieldOptions.writable`] = {
                key: "validator.object",
                value: value["fieldOptions"]["writable"],
                foundType: typeof value["fieldOptions"]["writable"],
              };
            } else {
              result["fieldOptions"]["writable"] = {
                $omit: undefined,
                $pick: undefined,
              };

              if (
                value["fieldOptions"]["writable"]["$omit"] === null ||
                value["fieldOptions"]["writable"]["$omit"] === undefined
              ) {
                result["fieldOptions"]["writable"]["$omit"] = undefined;
              } else {
                /** @type {ValidatorErrorMap} */
                const intermediateErrorMap18 = {};
                /** @type {Array<any>} */
                const intermediateResult18 = [];
                /** @type {any | Array<any>} */
                const intermediateValue18 =
                  value["fieldOptions"]["writable"]["$omit"];

                if (!Array.isArray(intermediateValue18)) {
                  errorMap[`$.fieldOptions.writable.$omit`] = {
                    key: "validator.array",
                    value: intermediateValue18,
                  };
                } else {
                  result["fieldOptions"]["writable"]["$omit"] = [];
                  for (let i18 = 0; i18 < intermediateValue18.length; ++i18) {
                    if (
                      intermediateValue18[i18] === null ||
                      intermediateValue18[i18] === undefined
                    ) {
                      intermediateErrorMap18[`$.${i18}`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString18 = intermediateValue18[i18];
                      if (typeof convertedString18 !== "string") {
                        intermediateErrorMap18[`$.${i18}`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString18.length < 1) {
                          intermediateErrorMap18[`$.${i18}`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          intermediateResult18[i18] = convertedString18;
                        }
                      }
                    }
                  }
                }
                if (Object.keys(intermediateErrorMap18).length) {
                  for (const errorKey of Object.keys(intermediateErrorMap18)) {
                    errorMap[
                      `$.fieldOptions.writable.$omit${errorKey.substring(1)}`
                    ] = intermediateErrorMap18[errorKey];
                  }
                } else {
                  result["fieldOptions"]["writable"]["$omit"] =
                    intermediateResult18;
                }
              }
              if (
                value["fieldOptions"]["writable"]["$pick"] === null ||
                value["fieldOptions"]["writable"]["$pick"] === undefined
              ) {
                result["fieldOptions"]["writable"]["$pick"] = undefined;
              } else {
                /** @type {ValidatorErrorMap} */
                const intermediateErrorMap19 = {};
                /** @type {Array<any>} */
                const intermediateResult19 = [];
                /** @type {any | Array<any>} */
                const intermediateValue19 =
                  value["fieldOptions"]["writable"]["$pick"];

                if (!Array.isArray(intermediateValue19)) {
                  errorMap[`$.fieldOptions.writable.$pick`] = {
                    key: "validator.array",
                    value: intermediateValue19,
                  };
                } else {
                  result["fieldOptions"]["writable"]["$pick"] = [];
                  for (let i19 = 0; i19 < intermediateValue19.length; ++i19) {
                    if (
                      intermediateValue19[i19] === null ||
                      intermediateValue19[i19] === undefined
                    ) {
                      intermediateErrorMap19[`$.${i19}`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString19 = intermediateValue19[i19];
                      if (typeof convertedString19 !== "string") {
                        intermediateErrorMap19[`$.${i19}`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString19.length < 1) {
                          intermediateErrorMap19[`$.${i19}`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          intermediateResult19[i19] = convertedString19;
                        }
                      }
                    }
                  }
                }
                if (Object.keys(intermediateErrorMap19).length) {
                  for (const errorKey of Object.keys(intermediateErrorMap19)) {
                    errorMap[
                      `$.fieldOptions.writable.$pick${errorKey.substring(1)}`
                    ] = intermediateErrorMap19[errorKey];
                  }
                } else {
                  result["fieldOptions"]["writable"]["$pick"] =
                    intermediateResult19;
                }
              }
            }
          }
        }
      }
      if (
        value["inlineRelations"] === null ||
        value["inlineRelations"] === undefined
      ) {
        errorMap[`$.inlineRelations`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap15 = {};
        /** @type {Array<any>} */
        const intermediateResult15 = [];
        /** @type {any | Array<any>} */
        const intermediateValue15 = value["inlineRelations"];

        if (!Array.isArray(intermediateValue15)) {
          errorMap[`$.inlineRelations`] = {
            key: "validator.array",
            value: intermediateValue15,
          };
        } else {
          result["inlineRelations"] = [];
          for (let i15 = 0; i15 < intermediateValue15.length; ++i15) {
            if (
              intermediateValue15[i15] === null ||
              intermediateValue15[i15] === undefined
            ) {
              intermediateErrorMap15[`$.${i15}`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult15 = validateStructureCrudDefinition(
                intermediateValue15[i15],
              );

              if (refResult15.error) {
                for (const errorKey of Object.keys(refResult15.error)) {
                  intermediateErrorMap15[`$.${i15}${errorKey.substring(1)}`] =
                    refResult15.error[errorKey];
                }
              }
              intermediateResult15[i15] = refResult15.value;
            }
          }
        }
        if (Object.keys(intermediateErrorMap15).length) {
          for (const errorKey of Object.keys(intermediateErrorMap15)) {
            errorMap[`$.inlineRelations${errorKey.substring(1)}`] =
              intermediateErrorMap15[errorKey];
          }
        } else {
          result["inlineRelations"] = intermediateResult15;
        }
      }
      if (
        value["nestedRelations"] === null ||
        value["nestedRelations"] === undefined
      ) {
        errorMap[`$.nestedRelations`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap16 = {};
        /** @type {Array<any>} */
        const intermediateResult16 = [];
        /** @type {any | Array<any>} */
        const intermediateValue16 = value["nestedRelations"];

        if (!Array.isArray(intermediateValue16)) {
          errorMap[`$.nestedRelations`] = {
            key: "validator.array",
            value: intermediateValue16,
          };
        } else {
          result["nestedRelations"] = [];
          for (let i16 = 0; i16 < intermediateValue16.length; ++i16) {
            if (
              intermediateValue16[i16] === null ||
              intermediateValue16[i16] === undefined
            ) {
              intermediateErrorMap16[`$.${i16}`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult16 = validateStructureCrudDefinition(
                intermediateValue16[i16],
              );

              if (refResult16.error) {
                for (const errorKey of Object.keys(refResult16.error)) {
                  intermediateErrorMap16[`$.${i16}${errorKey.substring(1)}`] =
                    refResult16.error[errorKey];
                }
              }
              intermediateResult16[i16] = refResult16.value;
            }
          }
        }
        if (Object.keys(intermediateErrorMap16).length) {
          for (const errorKey of Object.keys(intermediateErrorMap16)) {
            errorMap[`$.nestedRelations${errorKey.substring(1)}`] =
              intermediateErrorMap16[errorKey];
          }
        } else {
          result["nestedRelations"] = intermediateResult16;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureReferenceDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureReferenceDefinition, ValidatorErrorMap>}
 */
export function validateStructureReferenceDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        reference: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "reference") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["reference"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString2 = value["docString"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString2;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch4 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch4) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap6 = {};
          /** @type {any} */
          let intermediateResult6 = undefined;
          /** @type {any} */
          const intermediateValue6 = value["defaultValue"];

          if (intermediateValue6 === null || intermediateValue6 === undefined) {
            intermediateErrorMap6[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString6 = intermediateValue6;
            if (typeof convertedString6 !== "string") {
              intermediateErrorMap6[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString6.length < 1) {
                intermediateErrorMap6[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult6 = convertedString6;
              }
            }
          }
          if (Object.keys(intermediateErrorMap6).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap6);
          } else {
            hasAnyOfMatch4 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult6;
          }
        }
        if (!hasAnyOfMatch4) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap6 = {};
          /** @type {any} */
          let intermediateResult6 = undefined;
          /** @type {any} */
          const intermediateValue6 = value["defaultValue"];

          if (intermediateValue6 === null || intermediateValue6 === undefined) {
            intermediateErrorMap6[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue6 === true ||
              intermediateValue6 === "true" ||
              intermediateValue6 === 1 ||
              intermediateValue6 === "1"
            ) {
              intermediateResult6 = true;
            } else if (
              intermediateValue6 === false ||
              intermediateValue6 === "false" ||
              intermediateValue6 === 0 ||
              intermediateValue6 === "0"
            ) {
              intermediateResult6 = false;
            } else {
              intermediateErrorMap6[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap6).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap6);
          } else {
            hasAnyOfMatch4 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult6;
          }
        }
        if (!hasAnyOfMatch4) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap6 = {};
          /** @type {any} */
          let intermediateResult6 = undefined;
          /** @type {any} */
          const intermediateValue6 = value["defaultValue"];

          if (intermediateValue6 === null || intermediateValue6 === undefined) {
            intermediateErrorMap6[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber6 = intermediateValue6;
            if (
              typeof convertedNumber6 !== "number" &&
              typeof convertedNumber6 === "string"
            ) {
              convertedNumber6 = Number(convertedNumber6);
            }
            if (
              typeof convertedNumber6 !== "number" ||
              isNaN(convertedNumber6) ||
              !isFinite(convertedNumber6) ||
              !Number.isInteger(convertedNumber6)
            ) {
              intermediateErrorMap6[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber6 < -9007199254740991) {
              intermediateErrorMap6[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber6 > 9007199254740991) {
              intermediateErrorMap6[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult6 = convertedNumber6;
            }
          }
          if (Object.keys(intermediateErrorMap6).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap6);
          } else {
            hasAnyOfMatch4 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult6;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        result["validator"] = {};
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {};
        }
      }
      if (value["reference"] === null || value["reference"] === undefined) {
        errorMap[`$.reference`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["reference"])) {
          errorMap[`$.reference`] = {
            key: "validator.object",
            value: value["reference"],
            foundType: typeof value["reference"],
          };
        } else {
          result["reference"] = { group: undefined, name: undefined };

          if (
            value["reference"]["group"] === null ||
            value["reference"]["group"] === undefined
          ) {
            errorMap[`$.reference.group`] = {
              key: "validator.undefined",
            };
          } else {
            const refResult8 = validateStructureNamePart(
              value["reference"]["group"],
            );

            if (refResult8.error) {
              for (const errorKey of Object.keys(refResult8.error)) {
                errorMap[`$.reference.group${errorKey.substring(1)}`] =
                  refResult8.error[errorKey];
              }
            }
            result["reference"]["group"] = refResult8.value;
          }
          if (
            value["reference"]["name"] === null ||
            value["reference"]["name"] === undefined
          ) {
            errorMap[`$.reference.name`] = {
              key: "validator.undefined",
            };
          } else {
            const refResult9 = validateStructureNamePart(
              value["reference"]["name"],
            );

            if (refResult9.error) {
              for (const errorKey of Object.keys(refResult9.error)) {
                errorMap[`$.reference.name${errorKey.substring(1)}`] =
                  refResult9.error[errorKey];
              }
            }
            result["reference"]["name"] = refResult9.value;
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureNamePart|any} value
 * @returns {Either<import("../common/types.js").StructureNamePart, ValidatorErrorMap>}
 */
export function validateStructureNamePart(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    /** @type {string} */
    const convertedString0 = value;
    if (typeof convertedString0 !== "string") {
      errorMap[`$`] = {
        key: "validator.string",
      };
    } else {
      if (convertedString0.length < 1) {
        errorMap[`$`] = {
          key: "validator.length",
          minLength: 1,
        };
      } else if (!/^[a-zA-Z$][a-zA-Z\d]+$/g.test(convertedString0)) {
        errorMap[`$`] = {
          key: "validator.pattern",
        };
      } else {
        result = convertedString0;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureDateDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureDateDefinition, ValidatorErrorMap>}
 */
export function validateStructureDateDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        specifier: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "date") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["date"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {
            allowNull: undefined,
            min: undefined,
            max: undefined,
            inFuture: undefined,
            inPast: undefined,
          };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["min"] === null ||
            value["validator"]["min"] === undefined
          ) {
            result["validator"]["min"] = undefined;
          } else {
            if (
              typeof value["validator"]["min"] === "string" ||
              typeof value["validator"]["min"] === "number"
            ) {
              result["validator"]["min"] = new Date(value["validator"]["min"]);
            } else if (
              Object.prototype.toString.call(value["validator"]["min"]) ===
              "[object Date]"
            ) {
              result["validator"]["min"] = value["validator"]["min"];
            } else {
              errorMap[`$.validator.min`] = {
                key: "validator.type",
                expectedType: "Date|string",
              };
            }
            if (isNaN(result["validator"]["min"]?.getTime() ?? undefined)) {
              errorMap[`$.validator.min`] = {
                key: "validator.date.invalid",
              };
            }
          }
          if (
            value["validator"]["max"] === null ||
            value["validator"]["max"] === undefined
          ) {
            result["validator"]["max"] = undefined;
          } else {
            if (
              typeof value["validator"]["max"] === "string" ||
              typeof value["validator"]["max"] === "number"
            ) {
              result["validator"]["max"] = new Date(value["validator"]["max"]);
            } else if (
              Object.prototype.toString.call(value["validator"]["max"]) ===
              "[object Date]"
            ) {
              result["validator"]["max"] = value["validator"]["max"];
            } else {
              errorMap[`$.validator.max`] = {
                key: "validator.type",
                expectedType: "Date|string",
              };
            }
            if (isNaN(result["validator"]["max"]?.getTime() ?? undefined)) {
              errorMap[`$.validator.max`] = {
                key: "validator.date.invalid",
              };
            }
          }
          if (
            value["validator"]["inFuture"] === null ||
            value["validator"]["inFuture"] === undefined
          ) {
            result["validator"]["inFuture"] = undefined;
          } else {
            if (
              value["validator"]["inFuture"] === true ||
              value["validator"]["inFuture"] === "true" ||
              value["validator"]["inFuture"] === 1 ||
              value["validator"]["inFuture"] === "1"
            ) {
              result["validator"]["inFuture"] = true;
            } else if (
              value["validator"]["inFuture"] === false ||
              value["validator"]["inFuture"] === "false" ||
              value["validator"]["inFuture"] === 0 ||
              value["validator"]["inFuture"] === "0"
            ) {
              result["validator"]["inFuture"] = false;
            } else {
              errorMap[`$.validator.inFuture`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["inPast"] === null ||
            value["validator"]["inPast"] === undefined
          ) {
            result["validator"]["inPast"] = undefined;
          } else {
            if (
              value["validator"]["inPast"] === true ||
              value["validator"]["inPast"] === "true" ||
              value["validator"]["inPast"] === 1 ||
              value["validator"]["inPast"] === "1"
            ) {
              result["validator"]["inPast"] = true;
            } else if (
              value["validator"]["inPast"] === false ||
              value["validator"]["inPast"] === "false" ||
              value["validator"]["inPast"] === 0 ||
              value["validator"]["inPast"] === "0"
            ) {
              result["validator"]["inPast"] = false;
            } else {
              errorMap[`$.validator.inPast`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["specifier"] === null || value["specifier"] === undefined) {
        result["specifier"] = undefined;
      } else {
        /** @type {string} */
        const convertedString9 = value["specifier"];
        if (typeof convertedString9 !== "string") {
          errorMap[`$.specifier`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString9.length === 0) {
            result["specifier"] = undefined;
          } else {
            if (convertedString9.length < 1) {
              errorMap[`$.specifier`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else if (
              convertedString9 !== "dateOnly" &&
              convertedString9 !== "timeOnly"
            ) {
              errorMap[`$.specifier`] = {
                key: "validator.oneOf",
                allowedValues: ["dateOnly", "timeOnly"],
                foundValue: convertedString9,
              };
            } else {
              result["specifier"] = convertedString9;
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureExtendDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureExtendDefinition, ValidatorErrorMap>}
 */
export function validateStructureExtendDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        keys: undefined,
        reference: undefined,
        relations: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "extend") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["extend"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        result["validator"] = {};
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {};
        }
      }
      if (value["keys"] === null || value["keys"] === undefined) {
        errorMap[`$.keys`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["keys"])) {
          errorMap[`$.keys`] = {
            key: "validator.generic",
          };
        } else {
          result["keys"] = {};
          for (const genericKeyInput9 of Object.keys(value["keys"])) {
            /** @type {any} */
            let genericKeyResult10 = undefined;
            /** @type {ValidatorErrorMap} */
            const genericKeyErrorMap11 = {};
            if (genericKeyInput9 === null || genericKeyInput9 === undefined) {
              genericKeyErrorMap11[`$`] = {
                key: "validator.undefined",
              };
            } else {
              /** @type {string} */
              const convertedString12 = genericKeyInput9;
              if (typeof convertedString12 !== "string") {
                genericKeyErrorMap11[`$`] = {
                  key: "validator.string",
                };
              } else {
                if (convertedString12.length < 1) {
                  genericKeyErrorMap11[`$`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  genericKeyResult10 = convertedString12;
                }
              }
            }
            if (Object.keys(genericKeyErrorMap11).length !== 0) {
              if (errorMap[`$.keys`]) {
                errorMap[`$.keys`].inputs.push({
                  key: genericKeyInput9,
                  errors: genericKeyErrorMap11,
                });
              } else {
                errorMap[`$.keys`] = {
                  key: "validator.generic",
                  inputs: [
                    { key: genericKeyInput9, errors: genericKeyErrorMap11 },
                  ],
                };
              }
            } else {
              if (
                value["keys"][genericKeyResult10] === null ||
                value["keys"][genericKeyResult10] === undefined
              ) {
                errorMap[`$.keys.${genericKeyResult10}`] = {
                  key: "validator.undefined",
                };
              } else {
                const refResult12 = validateStructureTypeSystemDefinition(
                  value["keys"][genericKeyResult10],
                );

                if (refResult12.error) {
                  for (const errorKey of Object.keys(refResult12.error)) {
                    errorMap[
                      `$.keys.${genericKeyResult10}${errorKey.substring(1)}`
                    ] = refResult12.error[errorKey];
                  }
                }
                result["keys"][genericKeyResult10] = refResult12.value;
              }
            }
          }
        }
      }
      if (value["reference"] === null || value["reference"] === undefined) {
        errorMap[`$.reference`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult10 = validateStructureReferenceDefinition(
          value["reference"],
        );

        if (refResult10.error) {
          for (const errorKey of Object.keys(refResult10.error)) {
            errorMap[`$.reference${errorKey.substring(1)}`] =
              refResult10.error[errorKey];
          }
        }
        result["reference"] = refResult10.value;
      }
      if (value["relations"] === null || value["relations"] === undefined) {
        errorMap[`$.relations`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap12 = {};
        /** @type {Array<any>} */
        const intermediateResult12 = [];
        /** @type {any | Array<any>} */
        const intermediateValue12 = value["relations"];

        if (!Array.isArray(intermediateValue12)) {
          errorMap[`$.relations`] = {
            key: "validator.array",
            value: intermediateValue12,
          };
        } else {
          result["relations"] = [];
          for (let i12 = 0; i12 < intermediateValue12.length; ++i12) {
            if (
              intermediateValue12[i12] === null ||
              intermediateValue12[i12] === undefined
            ) {
              intermediateErrorMap12[`$.${i12}`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult12 = validateStructureRelationDefinition(
                intermediateValue12[i12],
              );

              if (refResult12.error) {
                for (const errorKey of Object.keys(refResult12.error)) {
                  intermediateErrorMap12[`$.${i12}${errorKey.substring(1)}`] =
                    refResult12.error[errorKey];
                }
              }
              intermediateResult12[i12] = refResult12.value;
            }
          }
        }
        if (Object.keys(intermediateErrorMap12).length) {
          for (const errorKey of Object.keys(intermediateErrorMap12)) {
            errorMap[`$.relations${errorKey.substring(1)}`] =
              intermediateErrorMap12[errorKey];
          }
        } else {
          result["relations"] = intermediateResult12;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureRelationDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureRelationDefinition, ValidatorErrorMap>}
 */
export function validateStructureRelationDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        subType: undefined,
        reference: undefined,
        ownKey: undefined,
        referencedKey: undefined,
        isOptional: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "relation") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["relation"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["subType"] === null || value["subType"] === undefined) {
        errorMap[`$.subType`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString2 = value["subType"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.subType`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length < 1) {
            errorMap[`$.subType`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (
            convertedString2 !== "manyToOne" &&
            convertedString2 !== "oneToMany" &&
            convertedString2 !== "oneToOne" &&
            convertedString2 !== "oneToOneReverse"
          ) {
            errorMap[`$.subType`] = {
              key: "validator.oneOf",
              allowedValues: [
                "manyToOne",
                "oneToMany",
                "oneToOne",
                "oneToOneReverse",
              ],
              foundValue: convertedString2,
            };
          } else {
            result["subType"] = convertedString2;
          }
        }
      }
      if (value["reference"] === null || value["reference"] === undefined) {
        errorMap[`$.reference`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult3 = validateStructureReferenceDefinition(
          value["reference"],
        );

        if (refResult3.error) {
          for (const errorKey of Object.keys(refResult3.error)) {
            errorMap[`$.reference${errorKey.substring(1)}`] =
              refResult3.error[errorKey];
          }
        }
        result["reference"] = refResult3.value;
      }
      if (value["ownKey"] === null || value["ownKey"] === undefined) {
        errorMap[`$.ownKey`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString4 = value["ownKey"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.ownKey`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length < 1) {
            errorMap[`$.ownKey`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else {
            result["ownKey"] = convertedString4;
          }
        }
      }
      if (
        value["referencedKey"] === null ||
        value["referencedKey"] === undefined
      ) {
        result["referencedKey"] = undefined;
      } else {
        /** @type {string} */
        const convertedString5 = value["referencedKey"];
        if (typeof convertedString5 !== "string") {
          errorMap[`$.referencedKey`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString5.length === 0) {
            result["referencedKey"] = undefined;
          } else {
            if (convertedString5.length < 1) {
              errorMap[`$.referencedKey`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["referencedKey"] = convertedString5;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        errorMap[`$.isOptional`] = {
          key: "validator.undefined",
        };
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureFileDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureFileDefinition, ValidatorErrorMap>}
 */
export function validateStructureFileDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "file") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["file"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { mimeTypes: undefined };

          if (
            value["validator"]["mimeTypes"] === null ||
            value["validator"]["mimeTypes"] === undefined
          ) {
            result["validator"]["mimeTypes"] = undefined;
          } else {
            /** @type {ValidatorErrorMap} */
            const intermediateErrorMap10 = {};
            /** @type {Array<any>} */
            const intermediateResult10 = [];
            /** @type {any | Array<any>} */
            const intermediateValue10 = value["validator"]["mimeTypes"];

            if (!Array.isArray(intermediateValue10)) {
              errorMap[`$.validator.mimeTypes`] = {
                key: "validator.array",
                value: intermediateValue10,
              };
            } else {
              result["validator"]["mimeTypes"] = [];
              for (let i10 = 0; i10 < intermediateValue10.length; ++i10) {
                if (
                  intermediateValue10[i10] === null ||
                  intermediateValue10[i10] === undefined
                ) {
                  intermediateErrorMap10[`$.${i10}`] = {
                    key: "validator.undefined",
                  };
                } else {
                  /** @type {string} */
                  const convertedString10 = intermediateValue10[i10];
                  if (typeof convertedString10 !== "string") {
                    intermediateErrorMap10[`$.${i10}`] = {
                      key: "validator.string",
                    };
                  } else {
                    if (convertedString10.length < 1) {
                      intermediateErrorMap10[`$.${i10}`] = {
                        key: "validator.length",
                        minLength: 1,
                      };
                    } else {
                      intermediateResult10[i10] = convertedString10;
                    }
                  }
                }
              }
            }
            if (Object.keys(intermediateErrorMap10).length) {
              for (const errorKey of Object.keys(intermediateErrorMap10)) {
                errorMap[`$.validator.mimeTypes${errorKey.substring(1)}`] =
                  intermediateErrorMap10[errorKey];
              }
            } else {
              result["validator"]["mimeTypes"] = intermediateResult10;
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureGenericDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureGenericDefinition, ValidatorErrorMap>}
 */
export function validateStructureGenericDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        keys: undefined,
        values: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "generic") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["generic"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        result["validator"] = {};
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {};
        }
      }
      if (value["keys"] === null || value["keys"] === undefined) {
        errorMap[`$.keys`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult9 = validateStructureTypeSystemDefinition(value["keys"]);

        if (refResult9.error) {
          for (const errorKey of Object.keys(refResult9.error)) {
            errorMap[`$.keys${errorKey.substring(1)}`] =
              refResult9.error[errorKey];
          }
        }
        result["keys"] = refResult9.value;
      }
      if (value["values"] === null || value["values"] === undefined) {
        errorMap[`$.values`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult10 = validateStructureTypeSystemDefinition(
          value["values"],
        );

        if (refResult10.error) {
          for (const errorKey of Object.keys(refResult10.error)) {
            errorMap[`$.values${errorKey.substring(1)}`] =
              refResult10.error[errorKey];
          }
        }
        result["values"] = refResult10.value;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureNumberDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureNumberDefinition, ValidatorErrorMap>}
 */
export function validateStructureNumberDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        oneOf: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "number") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["number"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {
            floatingPoint: undefined,
            min: undefined,
            max: undefined,
            allowNull: undefined,
          };

          if (
            value["validator"]["floatingPoint"] === null ||
            value["validator"]["floatingPoint"] === undefined
          ) {
            errorMap[`$.validator.floatingPoint`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["floatingPoint"] === true ||
              value["validator"]["floatingPoint"] === "true" ||
              value["validator"]["floatingPoint"] === 1 ||
              value["validator"]["floatingPoint"] === "1"
            ) {
              result["validator"]["floatingPoint"] = true;
            } else if (
              value["validator"]["floatingPoint"] === false ||
              value["validator"]["floatingPoint"] === "false" ||
              value["validator"]["floatingPoint"] === 0 ||
              value["validator"]["floatingPoint"] === "0"
            ) {
              result["validator"]["floatingPoint"] = false;
            } else {
              errorMap[`$.validator.floatingPoint`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["min"] === null ||
            value["validator"]["min"] === undefined
          ) {
            result["validator"]["min"] = undefined;
          } else {
            let convertedNumber10 = value["validator"]["min"];
            if (
              typeof convertedNumber10 !== "number" &&
              typeof convertedNumber10 === "string"
            ) {
              convertedNumber10 = Number(convertedNumber10);
            }
            if (
              typeof convertedNumber10 !== "number" ||
              isNaN(convertedNumber10) ||
              !isFinite(convertedNumber10) ||
              !Number.isInteger(convertedNumber10)
            ) {
              errorMap[`$.validator.min`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber10 < -9007199254740991) {
              errorMap[`$.validator.min`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber10 > 9007199254740991) {
              errorMap[`$.validator.min`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              result["validator"]["min"] = convertedNumber10;
            }
          }
          if (
            value["validator"]["max"] === null ||
            value["validator"]["max"] === undefined
          ) {
            result["validator"]["max"] = undefined;
          } else {
            let convertedNumber11 = value["validator"]["max"];
            if (
              typeof convertedNumber11 !== "number" &&
              typeof convertedNumber11 === "string"
            ) {
              convertedNumber11 = Number(convertedNumber11);
            }
            if (
              typeof convertedNumber11 !== "number" ||
              isNaN(convertedNumber11) ||
              !isFinite(convertedNumber11) ||
              !Number.isInteger(convertedNumber11)
            ) {
              errorMap[`$.validator.max`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber11 < -9007199254740991) {
              errorMap[`$.validator.max`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber11 > 9007199254740991) {
              errorMap[`$.validator.max`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              result["validator"]["max"] = convertedNumber11;
            }
          }
          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["oneOf"] === null || value["oneOf"] === undefined) {
        result["oneOf"] = undefined;
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap10 = {};
        /** @type {Array<any>} */
        const intermediateResult10 = [];
        /** @type {any | Array<any>} */
        const intermediateValue10 = value["oneOf"];

        if (!Array.isArray(intermediateValue10)) {
          errorMap[`$.oneOf`] = {
            key: "validator.array",
            value: intermediateValue10,
          };
        } else {
          result["oneOf"] = [];
          for (let i10 = 0; i10 < intermediateValue10.length; ++i10) {
            if (
              intermediateValue10[i10] === null ||
              intermediateValue10[i10] === undefined
            ) {
              intermediateErrorMap10[`$.${i10}`] = {
                key: "validator.undefined",
              };
            } else {
              let convertedNumber10 = intermediateValue10[i10];
              if (
                typeof convertedNumber10 !== "number" &&
                typeof convertedNumber10 === "string"
              ) {
                convertedNumber10 = Number(convertedNumber10);
              }
              if (
                typeof convertedNumber10 !== "number" ||
                isNaN(convertedNumber10) ||
                !isFinite(convertedNumber10) ||
                !Number.isInteger(convertedNumber10)
              ) {
                intermediateErrorMap10[`$.${i10}`] = {
                  key: "validator.number",
                  subType: "int",
                };
              } else if (convertedNumber10 < -9007199254740991) {
                intermediateErrorMap10[`$.${i10}`] = {
                  key: "validator.range",
                  minValue: -9007199254740991,
                };
              } else if (convertedNumber10 > 9007199254740991) {
                intermediateErrorMap10[`$.${i10}`] = {
                  key: "validator.range",
                  maxValue: 9007199254740991,
                };
              } else {
                intermediateResult10[i10] = convertedNumber10;
              }
            }
          }
        }
        if (Object.keys(intermediateErrorMap10).length) {
          for (const errorKey of Object.keys(intermediateErrorMap10)) {
            errorMap[`$.oneOf${errorKey.substring(1)}`] =
              intermediateErrorMap10[errorKey];
          }
        } else {
          result["oneOf"] = intermediateResult10;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureObjectDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureObjectDefinition, ValidatorErrorMap>}
 */
export function validateStructureObjectDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        shortName: undefined,
        keys: undefined,
        enableQueries: undefined,
        queryOptions: undefined,
        relations: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "object") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["object"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { allowNull: undefined, strict: undefined };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["strict"] === null ||
            value["validator"]["strict"] === undefined
          ) {
            errorMap[`$.validator.strict`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["strict"] === true ||
              value["validator"]["strict"] === "true" ||
              value["validator"]["strict"] === 1 ||
              value["validator"]["strict"] === "1"
            ) {
              result["validator"]["strict"] = true;
            } else if (
              value["validator"]["strict"] === false ||
              value["validator"]["strict"] === "false" ||
              value["validator"]["strict"] === 0 ||
              value["validator"]["strict"] === "0"
            ) {
              result["validator"]["strict"] = false;
            } else {
              errorMap[`$.validator.strict`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["shortName"] === null || value["shortName"] === undefined) {
        result["shortName"] = undefined;
      } else {
        /** @type {string} */
        const convertedString9 = value["shortName"];
        if (typeof convertedString9 !== "string") {
          errorMap[`$.shortName`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString9.length === 0) {
            result["shortName"] = undefined;
          } else {
            if (convertedString9.length < 1) {
              errorMap[`$.shortName`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["shortName"] = convertedString9;
            }
          }
        }
      }
      if (value["keys"] === null || value["keys"] === undefined) {
        errorMap[`$.keys`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["keys"])) {
          errorMap[`$.keys`] = {
            key: "validator.generic",
          };
        } else {
          result["keys"] = {};
          for (const genericKeyInput10 of Object.keys(value["keys"])) {
            /** @type {any} */
            let genericKeyResult11 = undefined;
            /** @type {ValidatorErrorMap} */
            const genericKeyErrorMap12 = {};
            if (genericKeyInput10 === null || genericKeyInput10 === undefined) {
              genericKeyErrorMap12[`$`] = {
                key: "validator.undefined",
              };
            } else {
              /** @type {string} */
              const convertedString13 = genericKeyInput10;
              if (typeof convertedString13 !== "string") {
                genericKeyErrorMap12[`$`] = {
                  key: "validator.string",
                };
              } else {
                if (convertedString13.length < 1) {
                  genericKeyErrorMap12[`$`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  genericKeyResult11 = convertedString13;
                }
              }
            }
            if (Object.keys(genericKeyErrorMap12).length !== 0) {
              if (errorMap[`$.keys`]) {
                errorMap[`$.keys`].inputs.push({
                  key: genericKeyInput10,
                  errors: genericKeyErrorMap12,
                });
              } else {
                errorMap[`$.keys`] = {
                  key: "validator.generic",
                  inputs: [
                    { key: genericKeyInput10, errors: genericKeyErrorMap12 },
                  ],
                };
              }
            } else {
              if (
                value["keys"][genericKeyResult11] === null ||
                value["keys"][genericKeyResult11] === undefined
              ) {
                errorMap[`$.keys.${genericKeyResult11}`] = {
                  key: "validator.undefined",
                };
              } else {
                const refResult13 = validateStructureTypeSystemDefinition(
                  value["keys"][genericKeyResult11],
                );

                if (refResult13.error) {
                  for (const errorKey of Object.keys(refResult13.error)) {
                    errorMap[
                      `$.keys.${genericKeyResult11}${errorKey.substring(1)}`
                    ] = refResult13.error[errorKey];
                  }
                }
                result["keys"][genericKeyResult11] = refResult13.value;
              }
            }
          }
        }
      }
      if (
        value["enableQueries"] === null ||
        value["enableQueries"] === undefined
      ) {
        result["enableQueries"] = undefined;
      } else {
        if (
          value["enableQueries"] === true ||
          value["enableQueries"] === "true" ||
          value["enableQueries"] === 1 ||
          value["enableQueries"] === "1"
        ) {
          result["enableQueries"] = true;
        } else if (
          value["enableQueries"] === false ||
          value["enableQueries"] === "false" ||
          value["enableQueries"] === 0 ||
          value["enableQueries"] === "0"
        ) {
          result["enableQueries"] = false;
        } else {
          errorMap[`$.enableQueries`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["queryOptions"] === null ||
        value["queryOptions"] === undefined
      ) {
        result["queryOptions"] = undefined;
      } else {
        if (!isRecord(value["queryOptions"])) {
          errorMap[`$.queryOptions`] = {
            key: "validator.object",
            value: value["queryOptions"],
            foundType: typeof value["queryOptions"],
          };
        } else {
          result["queryOptions"] = {
            withSoftDeletes: undefined,
            withDates: undefined,
            withPrimaryKey: undefined,
            isView: undefined,
            schema: undefined,
          };

          if (
            value["queryOptions"]["withSoftDeletes"] === null ||
            value["queryOptions"]["withSoftDeletes"] === undefined
          ) {
            result["queryOptions"]["withSoftDeletes"] = undefined;
          } else {
            if (
              value["queryOptions"]["withSoftDeletes"] === true ||
              value["queryOptions"]["withSoftDeletes"] === "true" ||
              value["queryOptions"]["withSoftDeletes"] === 1 ||
              value["queryOptions"]["withSoftDeletes"] === "1"
            ) {
              result["queryOptions"]["withSoftDeletes"] = true;
            } else if (
              value["queryOptions"]["withSoftDeletes"] === false ||
              value["queryOptions"]["withSoftDeletes"] === "false" ||
              value["queryOptions"]["withSoftDeletes"] === 0 ||
              value["queryOptions"]["withSoftDeletes"] === "0"
            ) {
              result["queryOptions"]["withSoftDeletes"] = false;
            } else {
              errorMap[`$.queryOptions.withSoftDeletes`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["queryOptions"]["withDates"] === null ||
            value["queryOptions"]["withDates"] === undefined
          ) {
            result["queryOptions"]["withDates"] = undefined;
          } else {
            if (
              value["queryOptions"]["withDates"] === true ||
              value["queryOptions"]["withDates"] === "true" ||
              value["queryOptions"]["withDates"] === 1 ||
              value["queryOptions"]["withDates"] === "1"
            ) {
              result["queryOptions"]["withDates"] = true;
            } else if (
              value["queryOptions"]["withDates"] === false ||
              value["queryOptions"]["withDates"] === "false" ||
              value["queryOptions"]["withDates"] === 0 ||
              value["queryOptions"]["withDates"] === "0"
            ) {
              result["queryOptions"]["withDates"] = false;
            } else {
              errorMap[`$.queryOptions.withDates`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["queryOptions"]["withPrimaryKey"] === null ||
            value["queryOptions"]["withPrimaryKey"] === undefined
          ) {
            errorMap[`$.queryOptions.withPrimaryKey`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["queryOptions"]["withPrimaryKey"] === true ||
              value["queryOptions"]["withPrimaryKey"] === "true" ||
              value["queryOptions"]["withPrimaryKey"] === 1 ||
              value["queryOptions"]["withPrimaryKey"] === "1"
            ) {
              result["queryOptions"]["withPrimaryKey"] = true;
            } else if (
              value["queryOptions"]["withPrimaryKey"] === false ||
              value["queryOptions"]["withPrimaryKey"] === "false" ||
              value["queryOptions"]["withPrimaryKey"] === 0 ||
              value["queryOptions"]["withPrimaryKey"] === "0"
            ) {
              result["queryOptions"]["withPrimaryKey"] = false;
            } else {
              errorMap[`$.queryOptions.withPrimaryKey`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["queryOptions"]["isView"] === null ||
            value["queryOptions"]["isView"] === undefined
          ) {
            result["queryOptions"]["isView"] = undefined;
          } else {
            if (
              value["queryOptions"]["isView"] === true ||
              value["queryOptions"]["isView"] === "true" ||
              value["queryOptions"]["isView"] === 1 ||
              value["queryOptions"]["isView"] === "1"
            ) {
              result["queryOptions"]["isView"] = true;
            } else if (
              value["queryOptions"]["isView"] === false ||
              value["queryOptions"]["isView"] === "false" ||
              value["queryOptions"]["isView"] === 0 ||
              value["queryOptions"]["isView"] === "0"
            ) {
              result["queryOptions"]["isView"] = false;
            } else {
              errorMap[`$.queryOptions.isView`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["queryOptions"]["schema"] === null ||
            value["queryOptions"]["schema"] === undefined
          ) {
            result["queryOptions"]["schema"] = undefined;
          } else {
            /** @type {string} */
            const convertedString17 = value["queryOptions"]["schema"];
            if (typeof convertedString17 !== "string") {
              errorMap[`$.queryOptions.schema`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString17.length === 0) {
                result["queryOptions"]["schema"] = undefined;
              } else {
                if (convertedString17.length < 1) {
                  errorMap[`$.queryOptions.schema`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  result["queryOptions"]["schema"] = convertedString17;
                }
              }
            }
          }
        }
      }
      if (value["relations"] === null || value["relations"] === undefined) {
        errorMap[`$.relations`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap14 = {};
        /** @type {Array<any>} */
        const intermediateResult14 = [];
        /** @type {any | Array<any>} */
        const intermediateValue14 = value["relations"];

        if (!Array.isArray(intermediateValue14)) {
          errorMap[`$.relations`] = {
            key: "validator.array",
            value: intermediateValue14,
          };
        } else {
          result["relations"] = [];
          for (let i14 = 0; i14 < intermediateValue14.length; ++i14) {
            if (
              intermediateValue14[i14] === null ||
              intermediateValue14[i14] === undefined
            ) {
              intermediateErrorMap14[`$.${i14}`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult14 = validateStructureRelationDefinition(
                intermediateValue14[i14],
              );

              if (refResult14.error) {
                for (const errorKey of Object.keys(refResult14.error)) {
                  intermediateErrorMap14[`$.${i14}${errorKey.substring(1)}`] =
                    refResult14.error[errorKey];
                }
              }
              intermediateResult14[i14] = refResult14.value;
            }
          }
        }
        if (Object.keys(intermediateErrorMap14).length) {
          for (const errorKey of Object.keys(intermediateErrorMap14)) {
            errorMap[`$.relations${errorKey.substring(1)}`] =
              intermediateErrorMap14[errorKey];
          }
        } else {
          result["relations"] = intermediateResult14;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureOmitDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureOmitDefinition, ValidatorErrorMap>}
 */
export function validateStructureOmitDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        keys: undefined,
        reference: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "omit") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["omit"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { allowNull: undefined, strict: undefined };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["strict"] === null ||
            value["validator"]["strict"] === undefined
          ) {
            errorMap[`$.validator.strict`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["strict"] === true ||
              value["validator"]["strict"] === "true" ||
              value["validator"]["strict"] === 1 ||
              value["validator"]["strict"] === "1"
            ) {
              result["validator"]["strict"] = true;
            } else if (
              value["validator"]["strict"] === false ||
              value["validator"]["strict"] === "false" ||
              value["validator"]["strict"] === 0 ||
              value["validator"]["strict"] === "0"
            ) {
              result["validator"]["strict"] = false;
            } else {
              errorMap[`$.validator.strict`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["keys"] === null || value["keys"] === undefined) {
        errorMap[`$.keys`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap10 = {};
        /** @type {Array<any>} */
        const intermediateResult10 = [];
        /** @type {any | Array<any>} */
        const intermediateValue10 = value["keys"];

        if (!Array.isArray(intermediateValue10)) {
          errorMap[`$.keys`] = {
            key: "validator.array",
            value: intermediateValue10,
          };
        } else {
          result["keys"] = [];
          for (let i10 = 0; i10 < intermediateValue10.length; ++i10) {
            if (
              intermediateValue10[i10] === null ||
              intermediateValue10[i10] === undefined
            ) {
              intermediateErrorMap10[`$.${i10}`] = {
                key: "validator.undefined",
              };
            } else {
              /** @type {string} */
              const convertedString10 = intermediateValue10[i10];
              if (typeof convertedString10 !== "string") {
                intermediateErrorMap10[`$.${i10}`] = {
                  key: "validator.string",
                };
              } else {
                if (convertedString10.length < 1) {
                  intermediateErrorMap10[`$.${i10}`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  intermediateResult10[i10] = convertedString10;
                }
              }
            }
          }
        }
        if (Object.keys(intermediateErrorMap10).length) {
          for (const errorKey of Object.keys(intermediateErrorMap10)) {
            errorMap[`$.keys${errorKey.substring(1)}`] =
              intermediateErrorMap10[errorKey];
          }
        } else {
          result["keys"] = intermediateResult10;
        }
      }
      if (value["reference"] === null || value["reference"] === undefined) {
        errorMap[`$.reference`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult10 = validateStructureTypeSystemDefinition(
          value["reference"],
        );

        if (refResult10.error) {
          for (const errorKey of Object.keys(refResult10.error)) {
            errorMap[`$.reference${errorKey.substring(1)}`] =
              refResult10.error[errorKey];
          }
        }
        result["reference"] = refResult10.value;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructurePickDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructurePickDefinition, ValidatorErrorMap>}
 */
export function validateStructurePickDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        keys: undefined,
        reference: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "pick") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["pick"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { allowNull: undefined, strict: undefined };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["strict"] === null ||
            value["validator"]["strict"] === undefined
          ) {
            errorMap[`$.validator.strict`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["strict"] === true ||
              value["validator"]["strict"] === "true" ||
              value["validator"]["strict"] === 1 ||
              value["validator"]["strict"] === "1"
            ) {
              result["validator"]["strict"] = true;
            } else if (
              value["validator"]["strict"] === false ||
              value["validator"]["strict"] === "false" ||
              value["validator"]["strict"] === 0 ||
              value["validator"]["strict"] === "0"
            ) {
              result["validator"]["strict"] = false;
            } else {
              errorMap[`$.validator.strict`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["keys"] === null || value["keys"] === undefined) {
        errorMap[`$.keys`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap10 = {};
        /** @type {Array<any>} */
        const intermediateResult10 = [];
        /** @type {any | Array<any>} */
        const intermediateValue10 = value["keys"];

        if (!Array.isArray(intermediateValue10)) {
          errorMap[`$.keys`] = {
            key: "validator.array",
            value: intermediateValue10,
          };
        } else {
          result["keys"] = [];
          for (let i10 = 0; i10 < intermediateValue10.length; ++i10) {
            if (
              intermediateValue10[i10] === null ||
              intermediateValue10[i10] === undefined
            ) {
              intermediateErrorMap10[`$.${i10}`] = {
                key: "validator.undefined",
              };
            } else {
              /** @type {string} */
              const convertedString10 = intermediateValue10[i10];
              if (typeof convertedString10 !== "string") {
                intermediateErrorMap10[`$.${i10}`] = {
                  key: "validator.string",
                };
              } else {
                if (convertedString10.length < 1) {
                  intermediateErrorMap10[`$.${i10}`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  intermediateResult10[i10] = convertedString10;
                }
              }
            }
          }
        }
        if (Object.keys(intermediateErrorMap10).length) {
          for (const errorKey of Object.keys(intermediateErrorMap10)) {
            errorMap[`$.keys${errorKey.substring(1)}`] =
              intermediateErrorMap10[errorKey];
          }
        } else {
          result["keys"] = intermediateResult10;
        }
      }
      if (value["reference"] === null || value["reference"] === undefined) {
        errorMap[`$.reference`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult10 = validateStructureTypeSystemDefinition(
          value["reference"],
        );

        if (refResult10.error) {
          for (const errorKey of Object.keys(refResult10.error)) {
            errorMap[`$.reference${errorKey.substring(1)}`] =
              refResult10.error[errorKey];
          }
        }
        result["reference"] = refResult10.value;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureStringDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureStringDefinition, ValidatorErrorMap>}
 */
export function validateStructureStringDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        oneOf: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "string") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["string"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {
            trim: undefined,
            lowerCase: undefined,
            upperCase: undefined,
            min: undefined,
            max: undefined,
            pattern: undefined,
            allowNull: undefined,
            disallowedCharacters: undefined,
          };

          if (
            value["validator"]["trim"] === null ||
            value["validator"]["trim"] === undefined
          ) {
            errorMap[`$.validator.trim`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["trim"] === true ||
              value["validator"]["trim"] === "true" ||
              value["validator"]["trim"] === 1 ||
              value["validator"]["trim"] === "1"
            ) {
              result["validator"]["trim"] = true;
            } else if (
              value["validator"]["trim"] === false ||
              value["validator"]["trim"] === "false" ||
              value["validator"]["trim"] === 0 ||
              value["validator"]["trim"] === "0"
            ) {
              result["validator"]["trim"] = false;
            } else {
              errorMap[`$.validator.trim`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["lowerCase"] === null ||
            value["validator"]["lowerCase"] === undefined
          ) {
            errorMap[`$.validator.lowerCase`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["lowerCase"] === true ||
              value["validator"]["lowerCase"] === "true" ||
              value["validator"]["lowerCase"] === 1 ||
              value["validator"]["lowerCase"] === "1"
            ) {
              result["validator"]["lowerCase"] = true;
            } else if (
              value["validator"]["lowerCase"] === false ||
              value["validator"]["lowerCase"] === "false" ||
              value["validator"]["lowerCase"] === 0 ||
              value["validator"]["lowerCase"] === "0"
            ) {
              result["validator"]["lowerCase"] = false;
            } else {
              errorMap[`$.validator.lowerCase`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["upperCase"] === null ||
            value["validator"]["upperCase"] === undefined
          ) {
            errorMap[`$.validator.upperCase`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              value["validator"]["upperCase"] === true ||
              value["validator"]["upperCase"] === "true" ||
              value["validator"]["upperCase"] === 1 ||
              value["validator"]["upperCase"] === "1"
            ) {
              result["validator"]["upperCase"] = true;
            } else if (
              value["validator"]["upperCase"] === false ||
              value["validator"]["upperCase"] === "false" ||
              value["validator"]["upperCase"] === 0 ||
              value["validator"]["upperCase"] === "0"
            ) {
              result["validator"]["upperCase"] = false;
            } else {
              errorMap[`$.validator.upperCase`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["min"] === null ||
            value["validator"]["min"] === undefined
          ) {
            result["validator"]["min"] = 1;
          } else {
            let convertedNumber12 = value["validator"]["min"];
            if (
              typeof convertedNumber12 !== "number" &&
              typeof convertedNumber12 === "string"
            ) {
              convertedNumber12 = Number(convertedNumber12);
            }
            if (
              typeof convertedNumber12 !== "number" ||
              isNaN(convertedNumber12) ||
              !isFinite(convertedNumber12) ||
              !Number.isInteger(convertedNumber12)
            ) {
              errorMap[`$.validator.min`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber12 < 0) {
              errorMap[`$.validator.min`] = {
                key: "validator.range",
                minValue: 0,
              };
            } else if (convertedNumber12 > 9007199254740991) {
              errorMap[`$.validator.min`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              result["validator"]["min"] = convertedNumber12;
            }
          }
          if (
            value["validator"]["max"] === null ||
            value["validator"]["max"] === undefined
          ) {
            result["validator"]["max"] = undefined;
          } else {
            let convertedNumber13 = value["validator"]["max"];
            if (
              typeof convertedNumber13 !== "number" &&
              typeof convertedNumber13 === "string"
            ) {
              convertedNumber13 = Number(convertedNumber13);
            }
            if (
              typeof convertedNumber13 !== "number" ||
              isNaN(convertedNumber13) ||
              !isFinite(convertedNumber13) ||
              !Number.isInteger(convertedNumber13)
            ) {
              errorMap[`$.validator.max`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber13 < 0) {
              errorMap[`$.validator.max`] = {
                key: "validator.range",
                minValue: 0,
              };
            } else if (convertedNumber13 > 9007199254740991) {
              errorMap[`$.validator.max`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              result["validator"]["max"] = convertedNumber13;
            }
          }
          if (
            value["validator"]["pattern"] === null ||
            value["validator"]["pattern"] === undefined
          ) {
            result["validator"]["pattern"] = undefined;
          } else {
            /** @type {string} */
            const convertedString14 = value["validator"]["pattern"];
            if (typeof convertedString14 !== "string") {
              errorMap[`$.validator.pattern`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString14.length === 0) {
                result["validator"]["pattern"] = undefined;
              } else {
                if (convertedString14.length < 1) {
                  errorMap[`$.validator.pattern`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  result["validator"]["pattern"] = convertedString14;
                }
              }
            }
          }
          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["validator"]["disallowedCharacters"] === null ||
            value["validator"]["disallowedCharacters"] === undefined
          ) {
            result["validator"]["disallowedCharacters"] = undefined;
          } else {
            /** @type {ValidatorErrorMap} */
            const intermediateErrorMap17 = {};
            /** @type {Array<any>} */
            const intermediateResult17 = [];
            /** @type {any | Array<any>} */
            const intermediateValue17 =
              value["validator"]["disallowedCharacters"];

            if (!Array.isArray(intermediateValue17)) {
              errorMap[`$.validator.disallowedCharacters`] = {
                key: "validator.array",
                value: intermediateValue17,
              };
            } else {
              result["validator"]["disallowedCharacters"] = [];
              for (let i17 = 0; i17 < intermediateValue17.length; ++i17) {
                if (
                  intermediateValue17[i17] === null ||
                  intermediateValue17[i17] === undefined
                ) {
                  intermediateErrorMap17[`$.${i17}`] = {
                    key: "validator.undefined",
                  };
                } else {
                  /** @type {string} */
                  const convertedString17 = intermediateValue17[i17];
                  if (typeof convertedString17 !== "string") {
                    intermediateErrorMap17[`$.${i17}`] = {
                      key: "validator.string",
                    };
                  } else {
                    if (convertedString17.length < 1) {
                      intermediateErrorMap17[`$.${i17}`] = {
                        key: "validator.length",
                        minLength: 1,
                      };
                    } else if (convertedString17.length > 2) {
                      intermediateErrorMap17[`$.${i17}`] = {
                        key: "validator.length",
                        maxLength: 2,
                      };
                    } else {
                      intermediateResult17[i17] = convertedString17;
                    }
                  }
                }
              }
            }
            if (Object.keys(intermediateErrorMap17).length) {
              for (const errorKey of Object.keys(intermediateErrorMap17)) {
                errorMap[
                  `$.validator.disallowedCharacters${errorKey.substring(1)}`
                ] = intermediateErrorMap17[errorKey];
              }
            } else {
              result["validator"]["disallowedCharacters"] =
                intermediateResult17;
            }
          }
        }
      }
      if (value["oneOf"] === null || value["oneOf"] === undefined) {
        result["oneOf"] = undefined;
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap10 = {};
        /** @type {Array<any>} */
        const intermediateResult10 = [];
        /** @type {any | Array<any>} */
        const intermediateValue10 = value["oneOf"];

        if (!Array.isArray(intermediateValue10)) {
          errorMap[`$.oneOf`] = {
            key: "validator.array",
            value: intermediateValue10,
          };
        } else {
          result["oneOf"] = [];
          for (let i10 = 0; i10 < intermediateValue10.length; ++i10) {
            if (
              intermediateValue10[i10] === null ||
              intermediateValue10[i10] === undefined
            ) {
              intermediateErrorMap10[`$.${i10}`] = {
                key: "validator.undefined",
              };
            } else {
              /** @type {string} */
              const convertedString10 = intermediateValue10[i10];
              if (typeof convertedString10 !== "string") {
                intermediateErrorMap10[`$.${i10}`] = {
                  key: "validator.string",
                };
              } else {
                if (convertedString10.length < 1) {
                  intermediateErrorMap10[`$.${i10}`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  intermediateResult10[i10] = convertedString10;
                }
              }
            }
          }
        }
        if (Object.keys(intermediateErrorMap10).length) {
          for (const errorKey of Object.keys(intermediateErrorMap10)) {
            errorMap[`$.oneOf${errorKey.substring(1)}`] =
              intermediateErrorMap10[errorKey];
          }
        } else {
          result["oneOf"] = intermediateResult10;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureUuidDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureUuidDefinition, ValidatorErrorMap>}
 */
export function validateStructureUuidDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "uuid") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["uuid"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        errorMap[`$.validator`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = { allowNull: undefined };

          if (
            value["validator"]["allowNull"] === null ||
            value["validator"]["allowNull"] === undefined
          ) {
            result["validator"]["allowNull"] = false;
          } else {
            if (
              value["validator"]["allowNull"] === true ||
              value["validator"]["allowNull"] === "true" ||
              value["validator"]["allowNull"] === 1 ||
              value["validator"]["allowNull"] === "1"
            ) {
              result["validator"]["allowNull"] = true;
            } else if (
              value["validator"]["allowNull"] === false ||
              value["validator"]["allowNull"] === "false" ||
              value["validator"]["allowNull"] === 0 ||
              value["validator"]["allowNull"] === "0"
            ) {
              result["validator"]["allowNull"] = false;
            } else {
              errorMap[`$.validator.allowNull`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * Select the targets and generators to be used when generating. See {@link https://compasjs.com/generators/targets.html} for more information.
 *
 * @param {import("../common/types.js").StructureGenerateOptionsInput|any} value
 * @returns {Either<import("../common/types.js").StructureGenerateOptions, ValidatorErrorMap>}
 */
export function validateStructureGenerateOptions(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        targetLanguage: undefined,
        outputDirectory: undefined,
        generators: undefined,
      };

      if (
        value["targetLanguage"] === null ||
        value["targetLanguage"] === undefined
      ) {
        errorMap[`$.targetLanguage`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["targetLanguage"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.targetLanguage`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.targetLanguage`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "js" && convertedString1 !== "ts") {
            errorMap[`$.targetLanguage`] = {
              key: "validator.oneOf",
              allowedValues: ["js", "ts"],
              foundValue: convertedString1,
            };
          } else {
            result["targetLanguage"] = convertedString1;
          }
        }
      }
      if (
        value["outputDirectory"] === null ||
        value["outputDirectory"] === undefined
      ) {
        result["outputDirectory"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["outputDirectory"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.outputDirectory`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["outputDirectory"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.outputDirectory`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["outputDirectory"] = convertedString2;
            }
          }
        }
      }
      if (value["generators"] === null || value["generators"] === undefined) {
        errorMap[`$.generators`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["generators"])) {
          errorMap[`$.generators`] = {
            key: "validator.object",
            value: value["generators"],
            foundType: typeof value["generators"],
          };
        } else {
          /** @type {Set<string>} */
          const knownKeys3 = new Set([
            "structure",
            "openApi",
            "router",
            "database",
            "validators",
            "apiClient",
            "types",
          ]);
          for (const key of Object.keys(value["generators"])) {
            if (
              !knownKeys3.has(key) &&
              value["generators"][key] !== null &&
              value["generators"][key] !== undefined
            ) {
              const expectedKeys = [...knownKeys3];
              const foundKeys = Object.keys(value["generators"]);
              const unknownKeys = foundKeys.filter((it) => !knownKeys3.has(it));
              errorMap[`$.generators`] = {
                key: "validator.keys",
                unknownKeys,
                expectedKeys,
                foundKeys,
              };
              break;
            }
          }
          result["generators"] = {
            structure: undefined,
            openApi: undefined,
            router: undefined,
            database: undefined,
            validators: undefined,
            apiClient: undefined,
            types: undefined,
          };

          if (
            value["generators"]["structure"] === null ||
            value["generators"]["structure"] === undefined
          ) {
            result["generators"]["structure"] = undefined;
          } else {
            if (!isRecord(value["generators"]["structure"])) {
              errorMap[`$.generators.structure`] = {
                key: "validator.object",
                value: value["generators"]["structure"],
                foundType: typeof value["generators"]["structure"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys4 = new Set([]);
              for (const key of Object.keys(value["generators"]["structure"])) {
                if (
                  !knownKeys4.has(key) &&
                  value["generators"]["structure"][key] !== null &&
                  value["generators"]["structure"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys4];
                  const foundKeys = Object.keys(
                    value["generators"]["structure"],
                  );
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys4.has(it),
                  );
                  errorMap[`$.generators.structure`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["structure"] = {};
            }
          }
          if (
            value["generators"]["openApi"] === null ||
            value["generators"]["openApi"] === undefined
          ) {
            result["generators"]["openApi"] = undefined;
          } else {
            if (!isRecord(value["generators"]["openApi"])) {
              errorMap[`$.generators.openApi`] = {
                key: "validator.object",
                value: value["generators"]["openApi"],
                foundType: typeof value["generators"]["openApi"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys5 = new Set([
                "openApiExtensions",
                "openApiRouteExtensions",
              ]);
              for (const key of Object.keys(value["generators"]["openApi"])) {
                if (
                  !knownKeys5.has(key) &&
                  value["generators"]["openApi"][key] !== null &&
                  value["generators"]["openApi"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys5];
                  const foundKeys = Object.keys(value["generators"]["openApi"]);
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys5.has(it),
                  );
                  errorMap[`$.generators.openApi`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["openApi"] = {
                openApiExtensions: undefined,
                openApiRouteExtensions: undefined,
              };

              if (
                value["generators"]["openApi"]["openApiExtensions"] === null ||
                value["generators"]["openApi"]["openApiExtensions"] ===
                  undefined
              ) {
                result["generators"]["openApi"]["openApiExtensions"] = {};
              } else {
                if (
                  !isRecord(value["generators"]["openApi"]["openApiExtensions"])
                ) {
                  errorMap[`$.generators.openApi.openApiExtensions`] = {
                    key: "validator.object",
                    value: value["generators"]["openApi"]["openApiExtensions"],
                    foundType:
                      typeof value["generators"]["openApi"][
                        "openApiExtensions"
                      ],
                  };
                } else {
                  /** @type {Set<string>} */
                  const knownKeys6 = new Set([
                    "version",
                    "title",
                    "description",
                  ]);
                  for (const key of Object.keys(
                    value["generators"]["openApi"]["openApiExtensions"],
                  )) {
                    if (
                      !knownKeys6.has(key) &&
                      value["generators"]["openApi"]["openApiExtensions"][
                        key
                      ] !== null &&
                      value["generators"]["openApi"]["openApiExtensions"][
                        key
                      ] !== undefined
                    ) {
                      const expectedKeys = [...knownKeys6];
                      const foundKeys = Object.keys(
                        value["generators"]["openApi"]["openApiExtensions"],
                      );
                      const unknownKeys = foundKeys.filter(
                        (it) => !knownKeys6.has(it),
                      );
                      errorMap[`$.generators.openApi.openApiExtensions`] = {
                        key: "validator.keys",
                        unknownKeys,
                        expectedKeys,
                        foundKeys,
                      };
                      break;
                    }
                  }
                  result["generators"]["openApi"]["openApiExtensions"] = {
                    version: undefined,
                    title: undefined,
                    description: undefined,
                  };

                  if (
                    value["generators"]["openApi"]["openApiExtensions"][
                      "version"
                    ] === null ||
                    value["generators"]["openApi"]["openApiExtensions"][
                      "version"
                    ] === undefined
                  ) {
                    result["generators"]["openApi"]["openApiExtensions"][
                      "version"
                    ] = undefined;
                  } else {
                    /** @type {string} */
                    const convertedString7 =
                      value["generators"]["openApi"]["openApiExtensions"][
                        "version"
                      ];
                    if (typeof convertedString7 !== "string") {
                      errorMap[
                        `$.generators.openApi.openApiExtensions.version`
                      ] = {
                        key: "validator.string",
                      };
                    } else {
                      if (convertedString7.length === 0) {
                        result["generators"]["openApi"]["openApiExtensions"][
                          "version"
                        ] = undefined;
                      } else {
                        if (convertedString7.length < 1) {
                          errorMap[
                            `$.generators.openApi.openApiExtensions.version`
                          ] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          result["generators"]["openApi"]["openApiExtensions"][
                            "version"
                          ] = convertedString7;
                        }
                      }
                    }
                  }
                  if (
                    value["generators"]["openApi"]["openApiExtensions"][
                      "title"
                    ] === null ||
                    value["generators"]["openApi"]["openApiExtensions"][
                      "title"
                    ] === undefined
                  ) {
                    result["generators"]["openApi"]["openApiExtensions"][
                      "title"
                    ] = undefined;
                  } else {
                    /** @type {string} */
                    const convertedString8 =
                      value["generators"]["openApi"]["openApiExtensions"][
                        "title"
                      ];
                    if (typeof convertedString8 !== "string") {
                      errorMap[`$.generators.openApi.openApiExtensions.title`] =
                        {
                          key: "validator.string",
                        };
                    } else {
                      if (convertedString8.length === 0) {
                        result["generators"]["openApi"]["openApiExtensions"][
                          "title"
                        ] = undefined;
                      } else {
                        if (convertedString8.length < 1) {
                          errorMap[
                            `$.generators.openApi.openApiExtensions.title`
                          ] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          result["generators"]["openApi"]["openApiExtensions"][
                            "title"
                          ] = convertedString8;
                        }
                      }
                    }
                  }
                  if (
                    value["generators"]["openApi"]["openApiExtensions"][
                      "description"
                    ] === null ||
                    value["generators"]["openApi"]["openApiExtensions"][
                      "description"
                    ] === undefined
                  ) {
                    result["generators"]["openApi"]["openApiExtensions"][
                      "description"
                    ] = undefined;
                  } else {
                    /** @type {string} */
                    const convertedString9 =
                      value["generators"]["openApi"]["openApiExtensions"][
                        "description"
                      ];
                    if (typeof convertedString9 !== "string") {
                      errorMap[
                        `$.generators.openApi.openApiExtensions.description`
                      ] = {
                        key: "validator.string",
                      };
                    } else {
                      if (convertedString9.length === 0) {
                        result["generators"]["openApi"]["openApiExtensions"][
                          "description"
                        ] = undefined;
                      } else {
                        if (convertedString9.length < 1) {
                          errorMap[
                            `$.generators.openApi.openApiExtensions.description`
                          ] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          result["generators"]["openApi"]["openApiExtensions"][
                            "description"
                          ] = convertedString9;
                        }
                      }
                    }
                  }
                }
              }
              if (
                value["generators"]["openApi"]["openApiRouteExtensions"] ===
                  null ||
                value["generators"]["openApi"]["openApiRouteExtensions"] ===
                  undefined
              ) {
                result["generators"]["openApi"]["openApiRouteExtensions"] = {};
              } else {
                if (
                  !isRecord(
                    value["generators"]["openApi"]["openApiRouteExtensions"],
                  )
                ) {
                  errorMap[`$.generators.openApi.openApiRouteExtensions`] = {
                    key: "validator.generic",
                  };
                } else {
                  result["generators"]["openApi"]["openApiRouteExtensions"] =
                    {};
                  for (const genericKeyInput7 of Object.keys(
                    value["generators"]["openApi"]["openApiRouteExtensions"],
                  )) {
                    /** @type {any} */
                    let genericKeyResult8 = undefined;
                    /** @type {ValidatorErrorMap} */
                    const genericKeyErrorMap9 = {};
                    if (
                      genericKeyInput7 === null ||
                      genericKeyInput7 === undefined
                    ) {
                      genericKeyErrorMap9[`$`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString10 = genericKeyInput7;
                      if (typeof convertedString10 !== "string") {
                        genericKeyErrorMap9[`$`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString10.length < 1) {
                          genericKeyErrorMap9[`$`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          genericKeyResult8 = convertedString10;
                        }
                      }
                    }
                    if (Object.keys(genericKeyErrorMap9).length !== 0) {
                      if (
                        errorMap[`$.generators.openApi.openApiRouteExtensions`]
                      ) {
                        errorMap[
                          `$.generators.openApi.openApiRouteExtensions`
                        ].inputs.push({
                          key: genericKeyInput7,
                          errors: genericKeyErrorMap9,
                        });
                      } else {
                        errorMap[
                          `$.generators.openApi.openApiRouteExtensions`
                        ] = {
                          key: "validator.generic",
                          inputs: [
                            {
                              key: genericKeyInput7,
                              errors: genericKeyErrorMap9,
                            },
                          ],
                        };
                      }
                    } else {
                      if (
                        value["generators"]["openApi"][
                          "openApiRouteExtensions"
                        ][genericKeyResult8] === null ||
                        value["generators"]["openApi"][
                          "openApiRouteExtensions"
                        ][genericKeyResult8] === undefined
                      ) {
                        errorMap[
                          `$.generators.openApi.openApiRouteExtensions.${genericKeyResult8}`
                        ] = {
                          key: "validator.undefined",
                        };
                      } else {
                        result["generators"]["openApi"][
                          "openApiRouteExtensions"
                        ][genericKeyResult8] =
                          value["generators"]["openApi"][
                            "openApiRouteExtensions"
                          ][genericKeyResult8];
                      }
                    }
                  }
                }
              }
            }
          }
          if (
            value["generators"]["router"] === null ||
            value["generators"]["router"] === undefined
          ) {
            result["generators"]["router"] = undefined;
          } else {
            if (!isRecord(value["generators"]["router"])) {
              errorMap[`$.generators.router`] = {
                key: "validator.object",
                value: value["generators"]["router"],
                foundType: typeof value["generators"]["router"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys6 = new Set(["target", "exposeApiStructure"]);
              for (const key of Object.keys(value["generators"]["router"])) {
                if (
                  !knownKeys6.has(key) &&
                  value["generators"]["router"][key] !== null &&
                  value["generators"]["router"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys6];
                  const foundKeys = Object.keys(value["generators"]["router"]);
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys6.has(it),
                  );
                  errorMap[`$.generators.router`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["router"] = {
                target: undefined,
                exposeApiStructure: undefined,
              };

              if (
                value["generators"]["router"]["target"] === null ||
                value["generators"]["router"]["target"] === undefined
              ) {
                errorMap[`$.generators.router.target`] = {
                  key: "validator.undefined",
                };
              } else {
                let hasAnyOfMatch7 = false;
                errorMap[`$.generators.router.target`] = {
                  key: "validator.anyOf",
                  errors: [],
                };
                if (!hasAnyOfMatch7) {
                  /** @type {ValidatorErrorMap} */
                  const intermediateErrorMap9 = {};
                  /** @type {any} */
                  let intermediateResult9 = undefined;
                  /** @type {any} */
                  const intermediateValue9 =
                    value["generators"]["router"]["target"];

                  if (
                    intermediateValue9 === null ||
                    intermediateValue9 === undefined
                  ) {
                    intermediateErrorMap9[`$`] = {
                      key: "validator.undefined",
                    };
                  } else {
                    if (!isRecord(intermediateValue9)) {
                      intermediateErrorMap9[`$`] = {
                        key: "validator.object",
                        value: intermediateValue9,
                        foundType: typeof intermediateValue9,
                      };
                    } else {
                      /** @type {Set<string>} */
                      const knownKeys9 = new Set(["library"]);
                      for (const key of Object.keys(intermediateValue9)) {
                        if (
                          !knownKeys9.has(key) &&
                          intermediateValue9[key] !== null &&
                          intermediateValue9[key] !== undefined
                        ) {
                          const expectedKeys = [...knownKeys9];
                          const foundKeys = Object.keys(intermediateValue9);
                          const unknownKeys = foundKeys.filter(
                            (it) => !knownKeys9.has(it),
                          );
                          intermediateErrorMap9[`$`] = {
                            key: "validator.keys",
                            unknownKeys,
                            expectedKeys,
                            foundKeys,
                          };
                          break;
                        }
                      }
                      intermediateResult9 = { library: undefined };

                      if (
                        intermediateValue9["library"] === null ||
                        intermediateValue9["library"] === undefined
                      ) {
                        intermediateErrorMap9[`$.library`] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {string} */
                        const convertedString10 = intermediateValue9["library"];
                        if (typeof convertedString10 !== "string") {
                          intermediateErrorMap9[`$.library`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString10.length < 1) {
                            intermediateErrorMap9[`$.library`] = {
                              key: "validator.length",
                              minLength: 1,
                            };
                          } else if (convertedString10 !== "koa") {
                            intermediateErrorMap9[`$.library`] = {
                              key: "validator.oneOf",
                              allowedValues: ["koa"],
                              foundValue: convertedString10,
                            };
                          } else {
                            intermediateResult9["library"] = convertedString10;
                          }
                        }
                      }
                    }
                  }
                  if (Object.keys(intermediateErrorMap9).length > 0) {
                    errorMap[`$.generators.router.target`].errors.push(
                      intermediateErrorMap9,
                    );
                  } else {
                    hasAnyOfMatch7 = true;
                    delete errorMap[`$.generators.router.target`];
                    result["generators"]["router"]["target"] =
                      intermediateResult9;
                  }
                }
              }
              if (
                value["generators"]["router"]["exposeApiStructure"] === null ||
                value["generators"]["router"]["exposeApiStructure"] ===
                  undefined
              ) {
                result["generators"]["router"]["exposeApiStructure"] = false;
              } else {
                if (
                  value["generators"]["router"]["exposeApiStructure"] ===
                    true ||
                  value["generators"]["router"]["exposeApiStructure"] ===
                    "true" ||
                  value["generators"]["router"]["exposeApiStructure"] === 1 ||
                  value["generators"]["router"]["exposeApiStructure"] === "1"
                ) {
                  result["generators"]["router"]["exposeApiStructure"] = true;
                } else if (
                  value["generators"]["router"]["exposeApiStructure"] ===
                    false ||
                  value["generators"]["router"]["exposeApiStructure"] ===
                    "false" ||
                  value["generators"]["router"]["exposeApiStructure"] === 0 ||
                  value["generators"]["router"]["exposeApiStructure"] === "0"
                ) {
                  result["generators"]["router"]["exposeApiStructure"] = false;
                } else {
                  errorMap[`$.generators.router.exposeApiStructure`] = {
                    key: "validator.type",
                    expectedType: "boolean",
                  };
                }
              }
            }
          }
          if (
            value["generators"]["database"] === null ||
            value["generators"]["database"] === undefined
          ) {
            result["generators"]["database"] = undefined;
          } else {
            if (!isRecord(value["generators"]["database"])) {
              errorMap[`$.generators.database`] = {
                key: "validator.object",
                value: value["generators"]["database"],
                foundType: typeof value["generators"]["database"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys7 = new Set(["target", "includeEntityDiagram"]);
              for (const key of Object.keys(value["generators"]["database"])) {
                if (
                  !knownKeys7.has(key) &&
                  value["generators"]["database"][key] !== null &&
                  value["generators"]["database"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys7];
                  const foundKeys = Object.keys(
                    value["generators"]["database"],
                  );
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys7.has(it),
                  );
                  errorMap[`$.generators.database`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["database"] = {
                target: undefined,
                includeEntityDiagram: undefined,
              };

              if (
                value["generators"]["database"]["target"] === null ||
                value["generators"]["database"]["target"] === undefined
              ) {
                errorMap[`$.generators.database.target`] = {
                  key: "validator.undefined",
                };
              } else {
                let hasAnyOfMatch8 = false;
                errorMap[`$.generators.database.target`] = {
                  key: "validator.anyOf",
                  errors: [],
                };
                if (!hasAnyOfMatch8) {
                  /** @type {ValidatorErrorMap} */
                  const intermediateErrorMap10 = {};
                  /** @type {any} */
                  let intermediateResult10 = undefined;
                  /** @type {any} */
                  const intermediateValue10 =
                    value["generators"]["database"]["target"];

                  if (
                    intermediateValue10 === null ||
                    intermediateValue10 === undefined
                  ) {
                    intermediateErrorMap10[`$`] = {
                      key: "validator.undefined",
                    };
                  } else {
                    if (!isRecord(intermediateValue10)) {
                      intermediateErrorMap10[`$`] = {
                        key: "validator.object",
                        value: intermediateValue10,
                        foundType: typeof intermediateValue10,
                      };
                    } else {
                      /** @type {Set<string>} */
                      const knownKeys10 = new Set(["dialect", "includeDDL"]);
                      for (const key of Object.keys(intermediateValue10)) {
                        if (
                          !knownKeys10.has(key) &&
                          intermediateValue10[key] !== null &&
                          intermediateValue10[key] !== undefined
                        ) {
                          const expectedKeys = [...knownKeys10];
                          const foundKeys = Object.keys(intermediateValue10);
                          const unknownKeys = foundKeys.filter(
                            (it) => !knownKeys10.has(it),
                          );
                          intermediateErrorMap10[`$`] = {
                            key: "validator.keys",
                            unknownKeys,
                            expectedKeys,
                            foundKeys,
                          };
                          break;
                        }
                      }
                      intermediateResult10 = {
                        dialect: undefined,
                        includeDDL: undefined,
                      };

                      if (
                        intermediateValue10["dialect"] === null ||
                        intermediateValue10["dialect"] === undefined
                      ) {
                        intermediateErrorMap10[`$.dialect`] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {string} */
                        const convertedString11 =
                          intermediateValue10["dialect"];
                        if (typeof convertedString11 !== "string") {
                          intermediateErrorMap10[`$.dialect`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString11.length < 1) {
                            intermediateErrorMap10[`$.dialect`] = {
                              key: "validator.length",
                              minLength: 1,
                            };
                          } else if (convertedString11 !== "postgres") {
                            intermediateErrorMap10[`$.dialect`] = {
                              key: "validator.oneOf",
                              allowedValues: ["postgres"],
                              foundValue: convertedString11,
                            };
                          } else {
                            intermediateResult10["dialect"] = convertedString11;
                          }
                        }
                      }
                      if (
                        intermediateValue10["includeDDL"] === null ||
                        intermediateValue10["includeDDL"] === undefined
                      ) {
                        intermediateResult10["includeDDL"] = false;
                      } else {
                        if (
                          intermediateValue10["includeDDL"] === true ||
                          intermediateValue10["includeDDL"] === "true" ||
                          intermediateValue10["includeDDL"] === 1 ||
                          intermediateValue10["includeDDL"] === "1"
                        ) {
                          intermediateResult10["includeDDL"] = true;
                        } else if (
                          intermediateValue10["includeDDL"] === false ||
                          intermediateValue10["includeDDL"] === "false" ||
                          intermediateValue10["includeDDL"] === 0 ||
                          intermediateValue10["includeDDL"] === "0"
                        ) {
                          intermediateResult10["includeDDL"] = false;
                        } else {
                          intermediateErrorMap10[`$.includeDDL`] = {
                            key: "validator.type",
                            expectedType: "boolean",
                          };
                        }
                      }
                    }
                  }
                  if (Object.keys(intermediateErrorMap10).length > 0) {
                    errorMap[`$.generators.database.target`].errors.push(
                      intermediateErrorMap10,
                    );
                  } else {
                    hasAnyOfMatch8 = true;
                    delete errorMap[`$.generators.database.target`];
                    result["generators"]["database"]["target"] =
                      intermediateResult10;
                  }
                }
              }
              if (
                value["generators"]["database"]["includeEntityDiagram"] ===
                  null ||
                value["generators"]["database"]["includeEntityDiagram"] ===
                  undefined
              ) {
                result["generators"]["database"]["includeEntityDiagram"] =
                  false;
              } else {
                if (
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    true ||
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    "true" ||
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    1 ||
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    "1"
                ) {
                  result["generators"]["database"]["includeEntityDiagram"] =
                    true;
                } else if (
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    false ||
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    "false" ||
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    0 ||
                  value["generators"]["database"]["includeEntityDiagram"] ===
                    "0"
                ) {
                  result["generators"]["database"]["includeEntityDiagram"] =
                    false;
                } else {
                  errorMap[`$.generators.database.includeEntityDiagram`] = {
                    key: "validator.type",
                    expectedType: "boolean",
                  };
                }
              }
            }
          }
          if (
            value["generators"]["validators"] === null ||
            value["generators"]["validators"] === undefined
          ) {
            result["generators"]["validators"] = undefined;
          } else {
            if (!isRecord(value["generators"]["validators"])) {
              errorMap[`$.generators.validators`] = {
                key: "validator.object",
                value: value["generators"]["validators"],
                foundType: typeof value["generators"]["validators"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys8 = new Set(["includeBaseTypes"]);
              for (const key of Object.keys(
                value["generators"]["validators"],
              )) {
                if (
                  !knownKeys8.has(key) &&
                  value["generators"]["validators"][key] !== null &&
                  value["generators"]["validators"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys8];
                  const foundKeys = Object.keys(
                    value["generators"]["validators"],
                  );
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys8.has(it),
                  );
                  errorMap[`$.generators.validators`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["validators"] = {
                includeBaseTypes: undefined,
              };

              if (
                value["generators"]["validators"]["includeBaseTypes"] ===
                  null ||
                value["generators"]["validators"]["includeBaseTypes"] ===
                  undefined
              ) {
                result["generators"]["validators"]["includeBaseTypes"] = false;
              } else {
                if (
                  value["generators"]["validators"]["includeBaseTypes"] ===
                    true ||
                  value["generators"]["validators"]["includeBaseTypes"] ===
                    "true" ||
                  value["generators"]["validators"]["includeBaseTypes"] === 1 ||
                  value["generators"]["validators"]["includeBaseTypes"] === "1"
                ) {
                  result["generators"]["validators"]["includeBaseTypes"] = true;
                } else if (
                  value["generators"]["validators"]["includeBaseTypes"] ===
                    false ||
                  value["generators"]["validators"]["includeBaseTypes"] ===
                    "false" ||
                  value["generators"]["validators"]["includeBaseTypes"] === 0 ||
                  value["generators"]["validators"]["includeBaseTypes"] === "0"
                ) {
                  result["generators"]["validators"]["includeBaseTypes"] =
                    false;
                } else {
                  errorMap[`$.generators.validators.includeBaseTypes`] = {
                    key: "validator.type",
                    expectedType: "boolean",
                  };
                }
              }
            }
          }
          if (
            value["generators"]["apiClient"] === null ||
            value["generators"]["apiClient"] === undefined
          ) {
            result["generators"]["apiClient"] = undefined;
          } else {
            if (!isRecord(value["generators"]["apiClient"])) {
              errorMap[`$.generators.apiClient`] = {
                key: "validator.object",
                value: value["generators"]["apiClient"],
                foundType: typeof value["generators"]["apiClient"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys9 = new Set(["target", "responseValidation"]);
              for (const key of Object.keys(value["generators"]["apiClient"])) {
                if (
                  !knownKeys9.has(key) &&
                  value["generators"]["apiClient"][key] !== null &&
                  value["generators"]["apiClient"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys9];
                  const foundKeys = Object.keys(
                    value["generators"]["apiClient"],
                  );
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys9.has(it),
                  );
                  errorMap[`$.generators.apiClient`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["apiClient"] = {
                target: undefined,
                responseValidation: undefined,
              };

              if (
                value["generators"]["apiClient"]["target"] === null ||
                value["generators"]["apiClient"]["target"] === undefined
              ) {
                errorMap[`$.generators.apiClient.target`] = {
                  key: "validator.undefined",
                };
              } else {
                let hasAnyOfMatch10 = false;
                errorMap[`$.generators.apiClient.target`] = {
                  key: "validator.anyOf",
                  errors: [],
                };
                if (!hasAnyOfMatch10) {
                  /** @type {ValidatorErrorMap} */
                  const intermediateErrorMap12 = {};
                  /** @type {any} */
                  let intermediateResult12 = undefined;
                  /** @type {any} */
                  const intermediateValue12 =
                    value["generators"]["apiClient"]["target"];

                  if (
                    intermediateValue12 === null ||
                    intermediateValue12 === undefined
                  ) {
                    intermediateErrorMap12[`$`] = {
                      key: "validator.undefined",
                    };
                  } else {
                    if (!isRecord(intermediateValue12)) {
                      intermediateErrorMap12[`$`] = {
                        key: "validator.object",
                        value: intermediateValue12,
                        foundType: typeof intermediateValue12,
                      };
                    } else {
                      /** @type {Set<string>} */
                      const knownKeys12 = new Set([
                        "library",
                        "targetRuntime",
                        "includeWrapper",
                        "globalClient",
                      ]);
                      for (const key of Object.keys(intermediateValue12)) {
                        if (
                          !knownKeys12.has(key) &&
                          intermediateValue12[key] !== null &&
                          intermediateValue12[key] !== undefined
                        ) {
                          const expectedKeys = [...knownKeys12];
                          const foundKeys = Object.keys(intermediateValue12);
                          const unknownKeys = foundKeys.filter(
                            (it) => !knownKeys12.has(it),
                          );
                          intermediateErrorMap12[`$`] = {
                            key: "validator.keys",
                            unknownKeys,
                            expectedKeys,
                            foundKeys,
                          };
                          break;
                        }
                      }
                      intermediateResult12 = {
                        library: undefined,
                        targetRuntime: undefined,
                        includeWrapper: undefined,
                        globalClient: undefined,
                      };

                      if (
                        intermediateValue12["library"] === null ||
                        intermediateValue12["library"] === undefined
                      ) {
                        intermediateErrorMap12[`$.library`] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {string} */
                        const convertedString13 =
                          intermediateValue12["library"];
                        if (typeof convertedString13 !== "string") {
                          intermediateErrorMap12[`$.library`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString13.length < 1) {
                            intermediateErrorMap12[`$.library`] = {
                              key: "validator.length",
                              minLength: 1,
                            };
                          } else if (convertedString13 !== "axios") {
                            intermediateErrorMap12[`$.library`] = {
                              key: "validator.oneOf",
                              allowedValues: ["axios"],
                              foundValue: convertedString13,
                            };
                          } else {
                            intermediateResult12["library"] = convertedString13;
                          }
                        }
                      }
                      if (
                        intermediateValue12["targetRuntime"] === null ||
                        intermediateValue12["targetRuntime"] === undefined
                      ) {
                        intermediateErrorMap12[`$.targetRuntime`] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {string} */
                        const convertedString14 =
                          intermediateValue12["targetRuntime"];
                        if (typeof convertedString14 !== "string") {
                          intermediateErrorMap12[`$.targetRuntime`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString14.length < 1) {
                            intermediateErrorMap12[`$.targetRuntime`] = {
                              key: "validator.length",
                              minLength: 1,
                            };
                          } else if (
                            convertedString14 !== "node.js" &&
                            convertedString14 !== "browser" &&
                            convertedString14 !== "react-native"
                          ) {
                            intermediateErrorMap12[`$.targetRuntime`] = {
                              key: "validator.oneOf",
                              allowedValues: [
                                "node.js",
                                "browser",
                                "react-native",
                              ],
                              foundValue: convertedString14,
                            };
                          } else {
                            intermediateResult12["targetRuntime"] =
                              convertedString14;
                          }
                        }
                      }
                      if (
                        intermediateValue12["includeWrapper"] === null ||
                        intermediateValue12["includeWrapper"] === undefined
                      ) {
                        intermediateResult12["includeWrapper"] = undefined;
                      } else {
                        /** @type {string} */
                        const convertedString15 =
                          intermediateValue12["includeWrapper"];
                        if (typeof convertedString15 !== "string") {
                          intermediateErrorMap12[`$.includeWrapper`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString15.length === 0) {
                            intermediateResult12["includeWrapper"] = undefined;
                          } else {
                            if (convertedString15.length < 1) {
                              intermediateErrorMap12[`$.includeWrapper`] = {
                                key: "validator.length",
                                minLength: 1,
                              };
                            } else if (convertedString15 !== "react-query") {
                              intermediateErrorMap12[`$.includeWrapper`] = {
                                key: "validator.oneOf",
                                allowedValues: ["react-query"],
                                foundValue: convertedString15,
                              };
                            } else {
                              intermediateResult12["includeWrapper"] =
                                convertedString15;
                            }
                          }
                        }
                      }
                      if (
                        intermediateValue12["globalClient"] === null ||
                        intermediateValue12["globalClient"] === undefined
                      ) {
                        intermediateResult12["globalClient"] = false;
                      } else {
                        if (
                          intermediateValue12["globalClient"] === true ||
                          intermediateValue12["globalClient"] === "true" ||
                          intermediateValue12["globalClient"] === 1 ||
                          intermediateValue12["globalClient"] === "1"
                        ) {
                          intermediateResult12["globalClient"] = true;
                        } else if (
                          intermediateValue12["globalClient"] === false ||
                          intermediateValue12["globalClient"] === "false" ||
                          intermediateValue12["globalClient"] === 0 ||
                          intermediateValue12["globalClient"] === "0"
                        ) {
                          intermediateResult12["globalClient"] = false;
                        } else {
                          intermediateErrorMap12[`$.globalClient`] = {
                            key: "validator.type",
                            expectedType: "boolean",
                          };
                        }
                      }
                    }
                  }
                  if (Object.keys(intermediateErrorMap12).length > 0) {
                    errorMap[`$.generators.apiClient.target`].errors.push(
                      intermediateErrorMap12,
                    );
                  } else {
                    hasAnyOfMatch10 = true;
                    delete errorMap[`$.generators.apiClient.target`];
                    result["generators"]["apiClient"]["target"] =
                      intermediateResult12;
                  }
                }
                if (!hasAnyOfMatch10) {
                  /** @type {ValidatorErrorMap} */
                  const intermediateErrorMap12 = {};
                  /** @type {any} */
                  let intermediateResult12 = undefined;
                  /** @type {any} */
                  const intermediateValue12 =
                    value["generators"]["apiClient"]["target"];

                  if (
                    intermediateValue12 === null ||
                    intermediateValue12 === undefined
                  ) {
                    intermediateErrorMap12[`$`] = {
                      key: "validator.undefined",
                    };
                  } else {
                    if (!isRecord(intermediateValue12)) {
                      intermediateErrorMap12[`$`] = {
                        key: "validator.object",
                        value: intermediateValue12,
                        foundType: typeof intermediateValue12,
                      };
                    } else {
                      /** @type {Set<string>} */
                      const knownKeys12 = new Set([
                        "library",
                        "targetRuntime",
                        "includeWrapper",
                        "globalClient",
                      ]);
                      for (const key of Object.keys(intermediateValue12)) {
                        if (
                          !knownKeys12.has(key) &&
                          intermediateValue12[key] !== null &&
                          intermediateValue12[key] !== undefined
                        ) {
                          const expectedKeys = [...knownKeys12];
                          const foundKeys = Object.keys(intermediateValue12);
                          const unknownKeys = foundKeys.filter(
                            (it) => !knownKeys12.has(it),
                          );
                          intermediateErrorMap12[`$`] = {
                            key: "validator.keys",
                            unknownKeys,
                            expectedKeys,
                            foundKeys,
                          };
                          break;
                        }
                      }
                      intermediateResult12 = {
                        library: undefined,
                        targetRuntime: undefined,
                        includeWrapper: undefined,
                        globalClient: undefined,
                      };

                      if (
                        intermediateValue12["library"] === null ||
                        intermediateValue12["library"] === undefined
                      ) {
                        intermediateErrorMap12[`$.library`] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {string} */
                        const convertedString13 =
                          intermediateValue12["library"];
                        if (typeof convertedString13 !== "string") {
                          intermediateErrorMap12[`$.library`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString13.length < 1) {
                            intermediateErrorMap12[`$.library`] = {
                              key: "validator.length",
                              minLength: 1,
                            };
                          } else if (convertedString13 !== "fetch") {
                            intermediateErrorMap12[`$.library`] = {
                              key: "validator.oneOf",
                              allowedValues: ["fetch"],
                              foundValue: convertedString13,
                            };
                          } else {
                            intermediateResult12["library"] = convertedString13;
                          }
                        }
                      }
                      if (
                        intermediateValue12["targetRuntime"] === null ||
                        intermediateValue12["targetRuntime"] === undefined
                      ) {
                        intermediateErrorMap12[`$.targetRuntime`] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {string} */
                        const convertedString14 =
                          intermediateValue12["targetRuntime"];
                        if (typeof convertedString14 !== "string") {
                          intermediateErrorMap12[`$.targetRuntime`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString14.length < 1) {
                            intermediateErrorMap12[`$.targetRuntime`] = {
                              key: "validator.length",
                              minLength: 1,
                            };
                          } else if (
                            convertedString14 !== "node.js" &&
                            convertedString14 !== "browser" &&
                            convertedString14 !== "react-native"
                          ) {
                            intermediateErrorMap12[`$.targetRuntime`] = {
                              key: "validator.oneOf",
                              allowedValues: [
                                "node.js",
                                "browser",
                                "react-native",
                              ],
                              foundValue: convertedString14,
                            };
                          } else {
                            intermediateResult12["targetRuntime"] =
                              convertedString14;
                          }
                        }
                      }
                      if (
                        intermediateValue12["includeWrapper"] === null ||
                        intermediateValue12["includeWrapper"] === undefined
                      ) {
                        intermediateResult12["includeWrapper"] = undefined;
                      } else {
                        /** @type {string} */
                        const convertedString15 =
                          intermediateValue12["includeWrapper"];
                        if (typeof convertedString15 !== "string") {
                          intermediateErrorMap12[`$.includeWrapper`] = {
                            key: "validator.string",
                          };
                        } else {
                          if (convertedString15.length === 0) {
                            intermediateResult12["includeWrapper"] = undefined;
                          } else {
                            if (convertedString15.length < 1) {
                              intermediateErrorMap12[`$.includeWrapper`] = {
                                key: "validator.length",
                                minLength: 1,
                              };
                            } else if (convertedString15 !== "react-query") {
                              intermediateErrorMap12[`$.includeWrapper`] = {
                                key: "validator.oneOf",
                                allowedValues: ["react-query"],
                                foundValue: convertedString15,
                              };
                            } else {
                              intermediateResult12["includeWrapper"] =
                                convertedString15;
                            }
                          }
                        }
                      }
                      if (
                        intermediateValue12["globalClient"] === null ||
                        intermediateValue12["globalClient"] === undefined
                      ) {
                        intermediateResult12["globalClient"] = false;
                      } else {
                        if (
                          intermediateValue12["globalClient"] === true ||
                          intermediateValue12["globalClient"] === "true" ||
                          intermediateValue12["globalClient"] === 1 ||
                          intermediateValue12["globalClient"] === "1"
                        ) {
                          intermediateResult12["globalClient"] = true;
                        } else if (
                          intermediateValue12["globalClient"] === false ||
                          intermediateValue12["globalClient"] === "false" ||
                          intermediateValue12["globalClient"] === 0 ||
                          intermediateValue12["globalClient"] === "0"
                        ) {
                          intermediateResult12["globalClient"] = false;
                        } else {
                          intermediateErrorMap12[`$.globalClient`] = {
                            key: "validator.type",
                            expectedType: "boolean",
                          };
                        }
                      }
                    }
                  }
                  if (Object.keys(intermediateErrorMap12).length > 0) {
                    errorMap[`$.generators.apiClient.target`].errors.push(
                      intermediateErrorMap12,
                    );
                  } else {
                    hasAnyOfMatch10 = true;
                    delete errorMap[`$.generators.apiClient.target`];
                    result["generators"]["apiClient"]["target"] =
                      intermediateResult12;
                  }
                }
              }
              if (
                value["generators"]["apiClient"]["responseValidation"] ===
                  null ||
                value["generators"]["apiClient"]["responseValidation"] ===
                  undefined
              ) {
                result["generators"]["apiClient"]["responseValidation"] = {
                  looseObjectValidation: true,
                };
              } else {
                if (
                  !isRecord(
                    value["generators"]["apiClient"]["responseValidation"],
                  )
                ) {
                  errorMap[`$.generators.apiClient.responseValidation`] = {
                    key: "validator.object",
                    value:
                      value["generators"]["apiClient"]["responseValidation"],
                    foundType:
                      typeof value["generators"]["apiClient"][
                        "responseValidation"
                      ],
                  };
                } else {
                  result["generators"]["apiClient"]["responseValidation"] = {
                    looseObjectValidation: undefined,
                  };

                  if (
                    value["generators"]["apiClient"]["responseValidation"][
                      "looseObjectValidation"
                    ] === null ||
                    value["generators"]["apiClient"]["responseValidation"][
                      "looseObjectValidation"
                    ] === undefined
                  ) {
                    errorMap[
                      `$.generators.apiClient.responseValidation.looseObjectValidation`
                    ] = {
                      key: "validator.undefined",
                    };
                  } else {
                    if (
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === true ||
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === "true" ||
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === 1 ||
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === "1"
                    ) {
                      result["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] = true;
                    } else if (
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === false ||
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === "false" ||
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === 0 ||
                      value["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] === "0"
                    ) {
                      result["generators"]["apiClient"]["responseValidation"][
                        "looseObjectValidation"
                      ] = false;
                    } else {
                      errorMap[
                        `$.generators.apiClient.responseValidation.looseObjectValidation`
                      ] = {
                        key: "validator.type",
                        expectedType: "boolean",
                      };
                    }
                  }
                }
              }
            }
          }
          if (
            value["generators"]["types"] === null ||
            value["generators"]["types"] === undefined
          ) {
            result["generators"]["types"] = undefined;
          } else {
            if (!isRecord(value["generators"]["types"])) {
              errorMap[`$.generators.types`] = {
                key: "validator.object",
                value: value["generators"]["types"],
                foundType: typeof value["generators"]["types"],
              };
            } else {
              /** @type {Set<string>} */
              const knownKeys10 = new Set([
                "includeBaseTypes",
                "declareGlobalTypes",
              ]);
              for (const key of Object.keys(value["generators"]["types"])) {
                if (
                  !knownKeys10.has(key) &&
                  value["generators"]["types"][key] !== null &&
                  value["generators"]["types"][key] !== undefined
                ) {
                  const expectedKeys = [...knownKeys10];
                  const foundKeys = Object.keys(value["generators"]["types"]);
                  const unknownKeys = foundKeys.filter(
                    (it) => !knownKeys10.has(it),
                  );
                  errorMap[`$.generators.types`] = {
                    key: "validator.keys",
                    unknownKeys,
                    expectedKeys,
                    foundKeys,
                  };
                  break;
                }
              }
              result["generators"]["types"] = {
                includeBaseTypes: undefined,
                declareGlobalTypes: undefined,
              };

              if (
                value["generators"]["types"]["includeBaseTypes"] === null ||
                value["generators"]["types"]["includeBaseTypes"] === undefined
              ) {
                result["generators"]["types"]["includeBaseTypes"] = false;
              } else {
                if (
                  value["generators"]["types"]["includeBaseTypes"] === true ||
                  value["generators"]["types"]["includeBaseTypes"] === "true" ||
                  value["generators"]["types"]["includeBaseTypes"] === 1 ||
                  value["generators"]["types"]["includeBaseTypes"] === "1"
                ) {
                  result["generators"]["types"]["includeBaseTypes"] = true;
                } else if (
                  value["generators"]["types"]["includeBaseTypes"] === false ||
                  value["generators"]["types"]["includeBaseTypes"] ===
                    "false" ||
                  value["generators"]["types"]["includeBaseTypes"] === 0 ||
                  value["generators"]["types"]["includeBaseTypes"] === "0"
                ) {
                  result["generators"]["types"]["includeBaseTypes"] = false;
                } else {
                  errorMap[`$.generators.types.includeBaseTypes`] = {
                    key: "validator.type",
                    expectedType: "boolean",
                  };
                }
              }
              if (
                value["generators"]["types"]["declareGlobalTypes"] === null ||
                value["generators"]["types"]["declareGlobalTypes"] === undefined
              ) {
                result["generators"]["types"]["declareGlobalTypes"] = false;
              } else {
                if (
                  value["generators"]["types"]["declareGlobalTypes"] === true ||
                  value["generators"]["types"]["declareGlobalTypes"] ===
                    "true" ||
                  value["generators"]["types"]["declareGlobalTypes"] === 1 ||
                  value["generators"]["types"]["declareGlobalTypes"] === "1"
                ) {
                  result["generators"]["types"]["declareGlobalTypes"] = true;
                } else if (
                  value["generators"]["types"]["declareGlobalTypes"] ===
                    false ||
                  value["generators"]["types"]["declareGlobalTypes"] ===
                    "false" ||
                  value["generators"]["types"]["declareGlobalTypes"] === 0 ||
                  value["generators"]["types"]["declareGlobalTypes"] === "0"
                ) {
                  result["generators"]["types"]["declareGlobalTypes"] = false;
                } else {
                  errorMap[`$.generators.types.declareGlobalTypes`] = {
                    key: "validator.type",
                    expectedType: "boolean",
                  };
                }
              }
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureNamePartOptional|any} value
 * @returns {Either<import("../common/types.js").StructureNamePartOptional, ValidatorErrorMap>}
 */
export function validateStructureNamePartOptional(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    result = undefined;
  } else {
    /** @type {string} */
    const convertedString0 = value;
    if (typeof convertedString0 !== "string") {
      errorMap[`$`] = {
        key: "validator.string",
      };
    } else {
      if (convertedString0.length === 0) {
        result = undefined;
      } else {
        if (convertedString0.length < 1) {
          errorMap[`$`] = {
            key: "validator.length",
            minLength: 1,
          };
        } else if (!/^[a-zA-Z$][a-zA-Z\d]+$/g.test(convertedString0)) {
          errorMap[`$`] = {
            key: "validator.pattern",
          };
        } else {
          result = convertedString0;
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * This contains all types that can be added top level to the structure.
 *
 * @param {import("../common/types.js").StructureNamedTypeDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureNamedTypeDefinition, ValidatorErrorMap>}
 */
export function validateStructureNamedTypeDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "any"
      ) {
        const refResult0 = validateStructureAnyDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "anyOf"
      ) {
        const refResult0 = validateStructureAnyOfDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "array"
      ) {
        const refResult0 = validateStructureArrayDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "boolean"
      ) {
        const refResult0 = validateStructureBooleanDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "crud"
      ) {
        const refResult0 = validateStructureCrudDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "date"
      ) {
        const refResult0 = validateStructureDateDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "extend"
      ) {
        const refResult0 = validateStructureExtendDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "file"
      ) {
        const refResult0 = validateStructureFileDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "generic"
      ) {
        const refResult0 = validateStructureGenericDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "number"
      ) {
        const refResult0 = validateStructureNumberDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "object"
      ) {
        const refResult0 = validateStructureObjectDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "omit"
      ) {
        const refResult0 = validateStructureOmitDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "pick"
      ) {
        const refResult0 = validateStructurePickDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "route"
      ) {
        const refResult0 = validateStructureRouteDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "string"
      ) {
        const refResult0 = validateStructureStringDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else if (
        typeof value === "object" &&
        "type" in value &&
        value.type === "uuid"
      ) {
        const refResult0 = validateStructureUuidDefinition(value);

        if (refResult0.error) {
          for (const errorKey of Object.keys(refResult0.error)) {
            errorMap[`$${errorKey.substring(1)}`] = refResult0.error[errorKey];
          }
        }
        result = refResult0.value;
      } else {
        errorMap[`$`] = {
          key: "validator.anyOf",
          discriminant: "type",
          foundValue: value.type,
          allowedValues: [
            "any",
            "anyOf",
            "array",
            "boolean",
            "crud",
            "date",
            "extend",
            "file",
            "generic",
            "number",
            "object",
            "omit",
            "pick",
            "route",
            "string",
            "uuid",
          ],
        };
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureRouteDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureRouteDefinition, ValidatorErrorMap>}
 */
export function validateStructureRouteDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = {
        type: undefined,
        group: undefined,
        name: undefined,
        docString: undefined,
        isOptional: undefined,
        defaultValue: undefined,
        sql: undefined,
        validator: undefined,
        method: undefined,
        idempotent: undefined,
        path: undefined,
        tags: undefined,
        query: undefined,
        params: undefined,
        body: undefined,
        response: undefined,
        invalidations: undefined,
        metadata: undefined,
      };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "route") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["route"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["group"] === null || value["group"] === undefined) {
        result["group"] = undefined;
      } else {
        /** @type {string} */
        const convertedString2 = value["group"];
        if (typeof convertedString2 !== "string") {
          errorMap[`$.group`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString2.length === 0) {
            result["group"] = undefined;
          } else {
            if (convertedString2.length < 1) {
              errorMap[`$.group`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["group"] = convertedString2;
            }
          }
        }
      }
      if (value["name"] === null || value["name"] === undefined) {
        result["name"] = undefined;
      } else {
        /** @type {string} */
        const convertedString3 = value["name"];
        if (typeof convertedString3 !== "string") {
          errorMap[`$.name`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString3.length === 0) {
            result["name"] = undefined;
          } else {
            if (convertedString3.length < 1) {
              errorMap[`$.name`] = {
                key: "validator.length",
                minLength: 1,
              };
            } else {
              result["name"] = convertedString3;
            }
          }
        }
      }
      if (value["docString"] === null || value["docString"] === undefined) {
        result["docString"] = "";
      } else {
        /** @type {string} */
        const convertedString4 = value["docString"];
        if (typeof convertedString4 !== "string") {
          errorMap[`$.docString`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString4.length === 0) {
            result["docString"] = "";
          } else {
            {
              result["docString"] = convertedString4;
            }
          }
        }
      }
      if (value["isOptional"] === null || value["isOptional"] === undefined) {
        result["isOptional"] = false;
      } else {
        if (
          value["isOptional"] === true ||
          value["isOptional"] === "true" ||
          value["isOptional"] === 1 ||
          value["isOptional"] === "1"
        ) {
          result["isOptional"] = true;
        } else if (
          value["isOptional"] === false ||
          value["isOptional"] === "false" ||
          value["isOptional"] === 0 ||
          value["isOptional"] === "0"
        ) {
          result["isOptional"] = false;
        } else {
          errorMap[`$.isOptional`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (
        value["defaultValue"] === null ||
        value["defaultValue"] === undefined
      ) {
        result["defaultValue"] = undefined;
      } else {
        let hasAnyOfMatch6 = false;
        errorMap[`$.defaultValue`] = {
          key: "validator.anyOf",
          errors: [],
        };
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            /** @type {string} */
            const convertedString8 = intermediateValue8;
            if (typeof convertedString8 !== "string") {
              intermediateErrorMap8[`$`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString8.length < 1) {
                intermediateErrorMap8[`$`] = {
                  key: "validator.length",
                  minLength: 1,
                };
              } else {
                intermediateResult8 = convertedString8;
              }
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            if (
              intermediateValue8 === true ||
              intermediateValue8 === "true" ||
              intermediateValue8 === 1 ||
              intermediateValue8 === "1"
            ) {
              intermediateResult8 = true;
            } else if (
              intermediateValue8 === false ||
              intermediateValue8 === "false" ||
              intermediateValue8 === 0 ||
              intermediateValue8 === "0"
            ) {
              intermediateResult8 = false;
            } else {
              intermediateErrorMap8[`$`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
        if (!hasAnyOfMatch6) {
          /** @type {ValidatorErrorMap} */
          const intermediateErrorMap8 = {};
          /** @type {any} */
          let intermediateResult8 = undefined;
          /** @type {any} */
          const intermediateValue8 = value["defaultValue"];

          if (intermediateValue8 === null || intermediateValue8 === undefined) {
            intermediateErrorMap8[`$`] = {
              key: "validator.undefined",
            };
          } else {
            let convertedNumber8 = intermediateValue8;
            if (
              typeof convertedNumber8 !== "number" &&
              typeof convertedNumber8 === "string"
            ) {
              convertedNumber8 = Number(convertedNumber8);
            }
            if (
              typeof convertedNumber8 !== "number" ||
              isNaN(convertedNumber8) ||
              !isFinite(convertedNumber8) ||
              !Number.isInteger(convertedNumber8)
            ) {
              intermediateErrorMap8[`$`] = {
                key: "validator.number",
                subType: "int",
              };
            } else if (convertedNumber8 < -9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                minValue: -9007199254740991,
              };
            } else if (convertedNumber8 > 9007199254740991) {
              intermediateErrorMap8[`$`] = {
                key: "validator.range",
                maxValue: 9007199254740991,
              };
            } else {
              intermediateResult8 = convertedNumber8;
            }
          }
          if (Object.keys(intermediateErrorMap8).length > 0) {
            errorMap[`$.defaultValue`].errors.push(intermediateErrorMap8);
          } else {
            hasAnyOfMatch6 = true;
            delete errorMap[`$.defaultValue`];
            result["defaultValue"] = intermediateResult8;
          }
        }
      }
      if (value["sql"] === null || value["sql"] === undefined) {
        result["sql"] = {};
      } else {
        if (!isRecord(value["sql"])) {
          errorMap[`$.sql`] = {
            key: "validator.object",
            value: value["sql"],
            foundType: typeof value["sql"],
          };
        } else {
          result["sql"] = {
            primary: undefined,
            searchable: undefined,
            hasDefaultValue: undefined,
          };

          if (
            value["sql"]["primary"] === null ||
            value["sql"]["primary"] === undefined
          ) {
            result["sql"]["primary"] = undefined;
          } else {
            if (
              value["sql"]["primary"] === true ||
              value["sql"]["primary"] === "true" ||
              value["sql"]["primary"] === 1 ||
              value["sql"]["primary"] === "1"
            ) {
              result["sql"]["primary"] = true;
            } else if (
              value["sql"]["primary"] === false ||
              value["sql"]["primary"] === "false" ||
              value["sql"]["primary"] === 0 ||
              value["sql"]["primary"] === "0"
            ) {
              result["sql"]["primary"] = false;
            } else {
              errorMap[`$.sql.primary`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["searchable"] === null ||
            value["sql"]["searchable"] === undefined
          ) {
            result["sql"]["searchable"] = undefined;
          } else {
            if (
              value["sql"]["searchable"] === true ||
              value["sql"]["searchable"] === "true" ||
              value["sql"]["searchable"] === 1 ||
              value["sql"]["searchable"] === "1"
            ) {
              result["sql"]["searchable"] = true;
            } else if (
              value["sql"]["searchable"] === false ||
              value["sql"]["searchable"] === "false" ||
              value["sql"]["searchable"] === 0 ||
              value["sql"]["searchable"] === "0"
            ) {
              result["sql"]["searchable"] = false;
            } else {
              errorMap[`$.sql.searchable`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["sql"]["hasDefaultValue"] === null ||
            value["sql"]["hasDefaultValue"] === undefined
          ) {
            result["sql"]["hasDefaultValue"] = undefined;
          } else {
            if (
              value["sql"]["hasDefaultValue"] === true ||
              value["sql"]["hasDefaultValue"] === "true" ||
              value["sql"]["hasDefaultValue"] === 1 ||
              value["sql"]["hasDefaultValue"] === "1"
            ) {
              result["sql"]["hasDefaultValue"] = true;
            } else if (
              value["sql"]["hasDefaultValue"] === false ||
              value["sql"]["hasDefaultValue"] === "false" ||
              value["sql"]["hasDefaultValue"] === 0 ||
              value["sql"]["hasDefaultValue"] === "0"
            ) {
              result["sql"]["hasDefaultValue"] = false;
            } else {
              errorMap[`$.sql.hasDefaultValue`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
        }
      }
      if (value["validator"] === null || value["validator"] === undefined) {
        result["validator"] = {};
      } else {
        if (!isRecord(value["validator"])) {
          errorMap[`$.validator`] = {
            key: "validator.object",
            value: value["validator"],
            foundType: typeof value["validator"],
          };
        } else {
          result["validator"] = {};
        }
      }
      if (value["method"] === null || value["method"] === undefined) {
        errorMap[`$.method`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString9 = value["method"];
        if (typeof convertedString9 !== "string") {
          errorMap[`$.method`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString9.length < 1) {
            errorMap[`$.method`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (
            convertedString9 !== "GET" &&
            convertedString9 !== "POST" &&
            convertedString9 !== "PUT" &&
            convertedString9 !== "DELETE" &&
            convertedString9 !== "HEAD" &&
            convertedString9 !== "PATCH"
          ) {
            errorMap[`$.method`] = {
              key: "validator.oneOf",
              allowedValues: ["GET", "POST", "PUT", "DELETE", "HEAD", "PATCH"],
              foundValue: convertedString9,
            };
          } else {
            result["method"] = convertedString9;
          }
        }
      }
      if (value["idempotent"] === null || value["idempotent"] === undefined) {
        errorMap[`$.idempotent`] = {
          key: "validator.undefined",
        };
      } else {
        if (
          value["idempotent"] === true ||
          value["idempotent"] === "true" ||
          value["idempotent"] === 1 ||
          value["idempotent"] === "1"
        ) {
          result["idempotent"] = true;
        } else if (
          value["idempotent"] === false ||
          value["idempotent"] === "false" ||
          value["idempotent"] === 0 ||
          value["idempotent"] === "0"
        ) {
          result["idempotent"] = false;
        } else {
          errorMap[`$.idempotent`] = {
            key: "validator.type",
            expectedType: "boolean",
          };
        }
      }
      if (value["path"] === null || value["path"] === undefined) {
        errorMap[`$.path`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString11 = value["path"];
        if (typeof convertedString11 !== "string") {
          errorMap[`$.path`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString11.length < 1) {
            errorMap[`$.path`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else {
            result["path"] = convertedString11;
          }
        }
      }
      if (value["tags"] === null || value["tags"] === undefined) {
        errorMap[`$.tags`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap13 = {};
        /** @type {Array<any>} */
        const intermediateResult13 = [];
        /** @type {any | Array<any>} */
        const intermediateValue13 = value["tags"];

        if (!Array.isArray(intermediateValue13)) {
          errorMap[`$.tags`] = {
            key: "validator.array",
            value: intermediateValue13,
          };
        } else {
          result["tags"] = [];
          for (let i13 = 0; i13 < intermediateValue13.length; ++i13) {
            if (
              intermediateValue13[i13] === null ||
              intermediateValue13[i13] === undefined
            ) {
              intermediateErrorMap13[`$.${i13}`] = {
                key: "validator.undefined",
              };
            } else {
              /** @type {string} */
              const convertedString13 = intermediateValue13[i13];
              if (typeof convertedString13 !== "string") {
                intermediateErrorMap13[`$.${i13}`] = {
                  key: "validator.string",
                };
              } else {
                if (convertedString13.length < 1) {
                  intermediateErrorMap13[`$.${i13}`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else {
                  intermediateResult13[i13] = convertedString13;
                }
              }
            }
          }
        }
        if (Object.keys(intermediateErrorMap13).length) {
          for (const errorKey of Object.keys(intermediateErrorMap13)) {
            errorMap[`$.tags${errorKey.substring(1)}`] =
              intermediateErrorMap13[errorKey];
          }
        } else {
          result["tags"] = intermediateResult13;
        }
      }
      if (value["query"] === null || value["query"] === undefined) {
        result["query"] = undefined;
      } else {
        const refResult13 = validateStructureReferenceDefinition(
          value["query"],
        );

        if (refResult13.error) {
          for (const errorKey of Object.keys(refResult13.error)) {
            errorMap[`$.query${errorKey.substring(1)}`] =
              refResult13.error[errorKey];
          }
        }
        result["query"] = refResult13.value;
      }
      if (value["params"] === null || value["params"] === undefined) {
        result["params"] = undefined;
      } else {
        const refResult14 = validateStructureReferenceDefinition(
          value["params"],
        );

        if (refResult14.error) {
          for (const errorKey of Object.keys(refResult14.error)) {
            errorMap[`$.params${errorKey.substring(1)}`] =
              refResult14.error[errorKey];
          }
        }
        result["params"] = refResult14.value;
      }
      if (value["body"] === null || value["body"] === undefined) {
        result["body"] = undefined;
      } else {
        const refResult15 = validateStructureReferenceDefinition(value["body"]);

        if (refResult15.error) {
          for (const errorKey of Object.keys(refResult15.error)) {
            errorMap[`$.body${errorKey.substring(1)}`] =
              refResult15.error[errorKey];
          }
        }
        result["body"] = refResult15.value;
      }
      if (value["response"] === null || value["response"] === undefined) {
        result["response"] = undefined;
      } else {
        const refResult16 = validateStructureReferenceDefinition(
          value["response"],
        );

        if (refResult16.error) {
          for (const errorKey of Object.keys(refResult16.error)) {
            errorMap[`$.response${errorKey.substring(1)}`] =
              refResult16.error[errorKey];
          }
        }
        result["response"] = refResult16.value;
      }
      if (
        value["invalidations"] === null ||
        value["invalidations"] === undefined
      ) {
        errorMap[`$.invalidations`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {ValidatorErrorMap} */
        const intermediateErrorMap18 = {};
        /** @type {Array<any>} */
        const intermediateResult18 = [];
        /** @type {any | Array<any>} */
        const intermediateValue18 = value["invalidations"];

        if (!Array.isArray(intermediateValue18)) {
          errorMap[`$.invalidations`] = {
            key: "validator.array",
            value: intermediateValue18,
          };
        } else {
          result["invalidations"] = [];
          for (let i18 = 0; i18 < intermediateValue18.length; ++i18) {
            if (
              intermediateValue18[i18] === null ||
              intermediateValue18[i18] === undefined
            ) {
              intermediateErrorMap18[`$.${i18}`] = {
                key: "validator.undefined",
              };
            } else {
              const refResult18 = validateStructureRouteInvalidationDefinition(
                intermediateValue18[i18],
              );

              if (refResult18.error) {
                for (const errorKey of Object.keys(refResult18.error)) {
                  intermediateErrorMap18[`$.${i18}${errorKey.substring(1)}`] =
                    refResult18.error[errorKey];
                }
              }
              intermediateResult18[i18] = refResult18.value;
            }
          }
        }
        if (Object.keys(intermediateErrorMap18).length) {
          for (const errorKey of Object.keys(intermediateErrorMap18)) {
            errorMap[`$.invalidations${errorKey.substring(1)}`] =
              intermediateErrorMap18[errorKey];
          }
        } else {
          result["invalidations"] = intermediateResult18;
        }
      }
      if (value["metadata"] === null || value["metadata"] === undefined) {
        result["metadata"] = undefined;
      } else {
        if (!isRecord(value["metadata"])) {
          errorMap[`$.metadata`] = {
            key: "validator.object",
            value: value["metadata"],
            foundType: typeof value["metadata"],
          };
        } else {
          result["metadata"] = { requestBodyType: undefined };

          if (
            value["metadata"]["requestBodyType"] === null ||
            value["metadata"]["requestBodyType"] === undefined
          ) {
            result["metadata"]["requestBodyType"] = undefined;
          } else {
            /** @type {string} */
            const convertedString19 = value["metadata"]["requestBodyType"];
            if (typeof convertedString19 !== "string") {
              errorMap[`$.metadata.requestBodyType`] = {
                key: "validator.string",
              };
            } else {
              if (convertedString19.length === 0) {
                result["metadata"]["requestBodyType"] = undefined;
              } else {
                if (convertedString19.length < 1) {
                  errorMap[`$.metadata.requestBodyType`] = {
                    key: "validator.length",
                    minLength: 1,
                  };
                } else if (
                  convertedString19 !== "json" &&
                  convertedString19 !== "form-data"
                ) {
                  errorMap[`$.metadata.requestBodyType`] = {
                    key: "validator.oneOf",
                    allowedValues: ["json", "form-data"],
                    foundValue: convertedString19,
                  };
                } else {
                  result["metadata"]["requestBodyType"] = convertedString19;
                }
              }
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureRouteInvalidationDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureRouteInvalidationDefinition, ValidatorErrorMap>}
 */
export function validateStructureRouteInvalidationDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.object",
        value: value,
        foundType: typeof value,
      };
    } else {
      result = { type: undefined, target: undefined, properties: undefined };

      if (value["type"] === null || value["type"] === undefined) {
        errorMap[`$.type`] = {
          key: "validator.undefined",
        };
      } else {
        /** @type {string} */
        const convertedString1 = value["type"];
        if (typeof convertedString1 !== "string") {
          errorMap[`$.type`] = {
            key: "validator.string",
          };
        } else {
          if (convertedString1.length < 1) {
            errorMap[`$.type`] = {
              key: "validator.length",
              minLength: 1,
            };
          } else if (convertedString1 !== "routeInvalidation") {
            errorMap[`$.type`] = {
              key: "validator.oneOf",
              allowedValues: ["routeInvalidation"],
              foundValue: convertedString1,
            };
          } else {
            result["type"] = convertedString1;
          }
        }
      }
      if (value["target"] === null || value["target"] === undefined) {
        errorMap[`$.target`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["target"])) {
          errorMap[`$.target`] = {
            key: "validator.object",
            value: value["target"],
            foundType: typeof value["target"],
          };
        } else {
          result["target"] = { group: undefined, name: undefined };

          if (
            value["target"]["group"] === null ||
            value["target"]["group"] === undefined
          ) {
            errorMap[`$.target.group`] = {
              key: "validator.undefined",
            };
          } else {
            const refResult3 = validateStructureNamePart(
              value["target"]["group"],
            );

            if (refResult3.error) {
              for (const errorKey of Object.keys(refResult3.error)) {
                errorMap[`$.target.group${errorKey.substring(1)}`] =
                  refResult3.error[errorKey];
              }
            }
            result["target"]["group"] = refResult3.value;
          }
          if (
            value["target"]["name"] === null ||
            value["target"]["name"] === undefined
          ) {
            result["target"]["name"] = undefined;
          } else {
            const refResult4 = validateStructureNamePartOptional(
              value["target"]["name"],
            );

            if (refResult4.error) {
              for (const errorKey of Object.keys(refResult4.error)) {
                errorMap[`$.target.name${errorKey.substring(1)}`] =
                  refResult4.error[errorKey];
              }
            }
            result["target"]["name"] = refResult4.value;
          }
        }
      }
      if (value["properties"] === null || value["properties"] === undefined) {
        errorMap[`$.properties`] = {
          key: "validator.undefined",
        };
      } else {
        if (!isRecord(value["properties"])) {
          errorMap[`$.properties`] = {
            key: "validator.object",
            value: value["properties"],
            foundType: typeof value["properties"],
          };
        } else {
          result["properties"] = {
            useSharedParams: undefined,
            useSharedQuery: undefined,
            specification: undefined,
          };

          if (
            value["properties"]["useSharedParams"] === null ||
            value["properties"]["useSharedParams"] === undefined
          ) {
            result["properties"]["useSharedParams"] = undefined;
          } else {
            if (
              value["properties"]["useSharedParams"] === true ||
              value["properties"]["useSharedParams"] === "true" ||
              value["properties"]["useSharedParams"] === 1 ||
              value["properties"]["useSharedParams"] === "1"
            ) {
              result["properties"]["useSharedParams"] = true;
            } else if (
              value["properties"]["useSharedParams"] === false ||
              value["properties"]["useSharedParams"] === "false" ||
              value["properties"]["useSharedParams"] === 0 ||
              value["properties"]["useSharedParams"] === "0"
            ) {
              result["properties"]["useSharedParams"] = false;
            } else {
              errorMap[`$.properties.useSharedParams`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["properties"]["useSharedQuery"] === null ||
            value["properties"]["useSharedQuery"] === undefined
          ) {
            result["properties"]["useSharedQuery"] = undefined;
          } else {
            if (
              value["properties"]["useSharedQuery"] === true ||
              value["properties"]["useSharedQuery"] === "true" ||
              value["properties"]["useSharedQuery"] === 1 ||
              value["properties"]["useSharedQuery"] === "1"
            ) {
              result["properties"]["useSharedQuery"] = true;
            } else if (
              value["properties"]["useSharedQuery"] === false ||
              value["properties"]["useSharedQuery"] === "false" ||
              value["properties"]["useSharedQuery"] === 0 ||
              value["properties"]["useSharedQuery"] === "0"
            ) {
              result["properties"]["useSharedQuery"] = false;
            } else {
              errorMap[`$.properties.useSharedQuery`] = {
                key: "validator.type",
                expectedType: "boolean",
              };
            }
          }
          if (
            value["properties"]["specification"] === null ||
            value["properties"]["specification"] === undefined
          ) {
            result["properties"]["specification"] = undefined;
          } else {
            if (!isRecord(value["properties"]["specification"])) {
              errorMap[`$.properties.specification`] = {
                key: "validator.object",
                value: value["properties"]["specification"],
                foundType: typeof value["properties"]["specification"],
              };
            } else {
              result["properties"]["specification"] = {
                params: undefined,
                query: undefined,
              };

              if (
                value["properties"]["specification"]["params"] === null ||
                value["properties"]["specification"]["params"] === undefined
              ) {
                errorMap[`$.properties.specification.params`] = {
                  key: "validator.undefined",
                };
              } else {
                if (!isRecord(value["properties"]["specification"]["params"])) {
                  errorMap[`$.properties.specification.params`] = {
                    key: "validator.generic",
                  };
                } else {
                  result["properties"]["specification"]["params"] = {};
                  for (const genericKeyInput7 of Object.keys(
                    value["properties"]["specification"]["params"],
                  )) {
                    /** @type {any} */
                    let genericKeyResult8 = undefined;
                    /** @type {ValidatorErrorMap} */
                    const genericKeyErrorMap9 = {};
                    if (
                      genericKeyInput7 === null ||
                      genericKeyInput7 === undefined
                    ) {
                      genericKeyErrorMap9[`$`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString10 = genericKeyInput7;
                      if (typeof convertedString10 !== "string") {
                        genericKeyErrorMap9[`$`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString10.length < 1) {
                          genericKeyErrorMap9[`$`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          genericKeyResult8 = convertedString10;
                        }
                      }
                    }
                    if (Object.keys(genericKeyErrorMap9).length !== 0) {
                      if (errorMap[`$.properties.specification.params`]) {
                        errorMap[
                          `$.properties.specification.params`
                        ].inputs.push({
                          key: genericKeyInput7,
                          errors: genericKeyErrorMap9,
                        });
                      } else {
                        errorMap[`$.properties.specification.params`] = {
                          key: "validator.generic",
                          inputs: [
                            {
                              key: genericKeyInput7,
                              errors: genericKeyErrorMap9,
                            },
                          ],
                        };
                      }
                    } else {
                      if (
                        value["properties"]["specification"]["params"][
                          genericKeyResult8
                        ] === null ||
                        value["properties"]["specification"]["params"][
                          genericKeyResult8
                        ] === undefined
                      ) {
                        errorMap[
                          `$.properties.specification.params.${genericKeyResult8}`
                        ] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {ValidatorErrorMap} */
                        const intermediateErrorMap11 = {};
                        /** @type {Array<any>} */
                        const intermediateResult11 = [];
                        /** @type {any | Array<any>} */
                        const intermediateValue11 =
                          value["properties"]["specification"]["params"][
                            genericKeyResult8
                          ];

                        if (!Array.isArray(intermediateValue11)) {
                          errorMap[
                            `$.properties.specification.params.${genericKeyResult8}`
                          ] = {
                            key: "validator.array",
                            value: intermediateValue11,
                          };
                        } else {
                          result["properties"]["specification"]["params"][
                            genericKeyResult8
                          ] = [];
                          for (
                            let i11 = 0;
                            i11 < intermediateValue11.length;
                            ++i11
                          ) {
                            if (
                              intermediateValue11[i11] === null ||
                              intermediateValue11[i11] === undefined
                            ) {
                              intermediateErrorMap11[`$.${i11}`] = {
                                key: "validator.undefined",
                              };
                            } else {
                              /** @type {string} */
                              const convertedString11 =
                                intermediateValue11[i11];
                              if (typeof convertedString11 !== "string") {
                                intermediateErrorMap11[`$.${i11}`] = {
                                  key: "validator.string",
                                };
                              } else {
                                if (convertedString11.length < 1) {
                                  intermediateErrorMap11[`$.${i11}`] = {
                                    key: "validator.length",
                                    minLength: 1,
                                  };
                                } else {
                                  intermediateResult11[i11] = convertedString11;
                                }
                              }
                            }
                          }
                        }
                        if (Object.keys(intermediateErrorMap11).length) {
                          for (const errorKey of Object.keys(
                            intermediateErrorMap11,
                          )) {
                            errorMap[
                              `$.properties.specification.params.${genericKeyResult8}${errorKey.substring(1)}`
                            ] = intermediateErrorMap11[errorKey];
                          }
                        } else {
                          result["properties"]["specification"]["params"][
                            genericKeyResult8
                          ] = intermediateResult11;
                        }
                      }
                    }
                  }
                }
              }
              if (
                value["properties"]["specification"]["query"] === null ||
                value["properties"]["specification"]["query"] === undefined
              ) {
                errorMap[`$.properties.specification.query`] = {
                  key: "validator.undefined",
                };
              } else {
                if (!isRecord(value["properties"]["specification"]["query"])) {
                  errorMap[`$.properties.specification.query`] = {
                    key: "validator.generic",
                  };
                } else {
                  result["properties"]["specification"]["query"] = {};
                  for (const genericKeyInput8 of Object.keys(
                    value["properties"]["specification"]["query"],
                  )) {
                    /** @type {any} */
                    let genericKeyResult9 = undefined;
                    /** @type {ValidatorErrorMap} */
                    const genericKeyErrorMap10 = {};
                    if (
                      genericKeyInput8 === null ||
                      genericKeyInput8 === undefined
                    ) {
                      genericKeyErrorMap10[`$`] = {
                        key: "validator.undefined",
                      };
                    } else {
                      /** @type {string} */
                      const convertedString11 = genericKeyInput8;
                      if (typeof convertedString11 !== "string") {
                        genericKeyErrorMap10[`$`] = {
                          key: "validator.string",
                        };
                      } else {
                        if (convertedString11.length < 1) {
                          genericKeyErrorMap10[`$`] = {
                            key: "validator.length",
                            minLength: 1,
                          };
                        } else {
                          genericKeyResult9 = convertedString11;
                        }
                      }
                    }
                    if (Object.keys(genericKeyErrorMap10).length !== 0) {
                      if (errorMap[`$.properties.specification.query`]) {
                        errorMap[
                          `$.properties.specification.query`
                        ].inputs.push({
                          key: genericKeyInput8,
                          errors: genericKeyErrorMap10,
                        });
                      } else {
                        errorMap[`$.properties.specification.query`] = {
                          key: "validator.generic",
                          inputs: [
                            {
                              key: genericKeyInput8,
                              errors: genericKeyErrorMap10,
                            },
                          ],
                        };
                      }
                    } else {
                      if (
                        value["properties"]["specification"]["query"][
                          genericKeyResult9
                        ] === null ||
                        value["properties"]["specification"]["query"][
                          genericKeyResult9
                        ] === undefined
                      ) {
                        errorMap[
                          `$.properties.specification.query.${genericKeyResult9}`
                        ] = {
                          key: "validator.undefined",
                        };
                      } else {
                        /** @type {ValidatorErrorMap} */
                        const intermediateErrorMap12 = {};
                        /** @type {Array<any>} */
                        const intermediateResult12 = [];
                        /** @type {any | Array<any>} */
                        const intermediateValue12 =
                          value["properties"]["specification"]["query"][
                            genericKeyResult9
                          ];

                        if (!Array.isArray(intermediateValue12)) {
                          errorMap[
                            `$.properties.specification.query.${genericKeyResult9}`
                          ] = {
                            key: "validator.array",
                            value: intermediateValue12,
                          };
                        } else {
                          result["properties"]["specification"]["query"][
                            genericKeyResult9
                          ] = [];
                          for (
                            let i12 = 0;
                            i12 < intermediateValue12.length;
                            ++i12
                          ) {
                            if (
                              intermediateValue12[i12] === null ||
                              intermediateValue12[i12] === undefined
                            ) {
                              intermediateErrorMap12[`$.${i12}`] = {
                                key: "validator.undefined",
                              };
                            } else {
                              /** @type {string} */
                              const convertedString12 =
                                intermediateValue12[i12];
                              if (typeof convertedString12 !== "string") {
                                intermediateErrorMap12[`$.${i12}`] = {
                                  key: "validator.string",
                                };
                              } else {
                                if (convertedString12.length < 1) {
                                  intermediateErrorMap12[`$.${i12}`] = {
                                    key: "validator.length",
                                    minLength: 1,
                                  };
                                } else {
                                  intermediateResult12[i12] = convertedString12;
                                }
                              }
                            }
                          }
                        }
                        if (Object.keys(intermediateErrorMap12).length) {
                          for (const errorKey of Object.keys(
                            intermediateErrorMap12,
                          )) {
                            errorMap[
                              `$.properties.specification.query.${genericKeyResult9}${errorKey.substring(1)}`
                            ] = intermediateErrorMap12[errorKey];
                          }
                        } else {
                          result["properties"]["specification"]["query"][
                            genericKeyResult9
                          ] = intermediateResult12;
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * @param {import("../common/types.js").StructureStructureInput|any} value
 * @returns {Either<import("../common/types.js").StructureStructure, ValidatorErrorMap>}
 */
export function validateStructureStructure(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    if (!isRecord(value)) {
      errorMap[`$`] = {
        key: "validator.generic",
      };
    } else {
      result = {};
      for (const genericKeyInput0 of Object.keys(value)) {
        /** @type {any} */
        let genericKeyResult1 = undefined;
        /** @type {ValidatorErrorMap} */
        const genericKeyErrorMap2 = {};
        if (genericKeyInput0 === null || genericKeyInput0 === undefined) {
          genericKeyErrorMap2[`$`] = {
            key: "validator.undefined",
          };
        } else {
          const refResult3 = validateStructureNamePart(genericKeyInput0);

          if (refResult3.error) {
            for (const errorKey of Object.keys(refResult3.error)) {
              genericKeyErrorMap2[`$${errorKey.substring(1)}`] =
                refResult3.error[errorKey];
            }
          }
          genericKeyResult1 = refResult3.value;
        }
        if (Object.keys(genericKeyErrorMap2).length !== 0) {
          if (errorMap[`$`]) {
            errorMap[`$`].inputs.push({
              key: genericKeyInput0,
              errors: genericKeyErrorMap2,
            });
          } else {
            errorMap[`$`] = {
              key: "validator.generic",
              inputs: [{ key: genericKeyInput0, errors: genericKeyErrorMap2 }],
            };
          }
        } else {
          if (
            value[genericKeyResult1] === null ||
            value[genericKeyResult1] === undefined
          ) {
            errorMap[`$.${genericKeyResult1}`] = {
              key: "validator.undefined",
            };
          } else {
            if (!isRecord(value[genericKeyResult1])) {
              errorMap[`$.${genericKeyResult1}`] = {
                key: "validator.generic",
              };
            } else {
              result[genericKeyResult1] = {};
              for (const genericKeyInput3 of Object.keys(
                value[genericKeyResult1],
              )) {
                /** @type {any} */
                let genericKeyResult4 = undefined;
                /** @type {ValidatorErrorMap} */
                const genericKeyErrorMap5 = {};
                if (
                  genericKeyInput3 === null ||
                  genericKeyInput3 === undefined
                ) {
                  genericKeyErrorMap5[`$`] = {
                    key: "validator.undefined",
                  };
                } else {
                  const refResult6 =
                    validateStructureNamePart(genericKeyInput3);

                  if (refResult6.error) {
                    for (const errorKey of Object.keys(refResult6.error)) {
                      genericKeyErrorMap5[`$${errorKey.substring(1)}`] =
                        refResult6.error[errorKey];
                    }
                  }
                  genericKeyResult4 = refResult6.value;
                }
                if (Object.keys(genericKeyErrorMap5).length !== 0) {
                  if (errorMap[`$.${genericKeyResult1}`]) {
                    errorMap[`$.${genericKeyResult1}`].inputs.push({
                      key: genericKeyInput3,
                      errors: genericKeyErrorMap5,
                    });
                  } else {
                    errorMap[`$.${genericKeyResult1}`] = {
                      key: "validator.generic",
                      inputs: [
                        { key: genericKeyInput3, errors: genericKeyErrorMap5 },
                      ],
                    };
                  }
                } else {
                  if (
                    value[genericKeyResult1][genericKeyResult4] === null ||
                    value[genericKeyResult1][genericKeyResult4] === undefined
                  ) {
                    errorMap[`$.${genericKeyResult1}.${genericKeyResult4}`] = {
                      key: "validator.undefined",
                    };
                  } else {
                    const refResult6 = validateStructureNamedTypeDefinition(
                      value[genericKeyResult1][genericKeyResult4],
                    );

                    if (refResult6.error) {
                      for (const errorKey of Object.keys(refResult6.error)) {
                        errorMap[
                          `$.${genericKeyResult1}.${genericKeyResult4}${errorKey.substring(1)}`
                        ] = refResult6.error[errorKey];
                      }
                    }
                    result[genericKeyResult1][genericKeyResult4] =
                      refResult6.value;
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}

/**
 * This contains all known type definitions.
 *
 * @param {import("../common/types.js").StructureTypeDefinitionInput|any} value
 * @returns {Either<import("../common/types.js").StructureTypeDefinition, ValidatorErrorMap>}
 */
export function validateStructureTypeDefinition(value) {
  /** @type {ValidatorErrorMap} */
  const errorMap = {};
  /** @type {any} */
  let result = undefined;

  if (value === null || value === undefined) {
    errorMap[`$`] = {
      key: "validator.undefined",
    };
  } else {
    let hasAnyOfMatch0 = false;
    errorMap[`$`] = {
      key: "validator.anyOf",
      errors: [],
    };
    if (!hasAnyOfMatch0) {
      /** @type {ValidatorErrorMap} */
      const intermediateErrorMap2 = {};
      /** @type {any} */
      let intermediateResult2 = undefined;
      /** @type {any} */
      const intermediateValue2 = value;

      if (intermediateValue2 === null || intermediateValue2 === undefined) {
        intermediateErrorMap2[`$`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult2 =
          validateStructureNamedTypeDefinition(intermediateValue2);

        if (refResult2.error) {
          for (const errorKey of Object.keys(refResult2.error)) {
            intermediateErrorMap2[`$${errorKey.substring(1)}`] =
              refResult2.error[errorKey];
          }
        }
        intermediateResult2 = refResult2.value;
      }
      if (Object.keys(intermediateErrorMap2).length > 0) {
        errorMap[`$`].errors.push(intermediateErrorMap2);
      } else {
        hasAnyOfMatch0 = true;
        delete errorMap[`$`];
        result = intermediateResult2;
      }
    }
    if (!hasAnyOfMatch0) {
      /** @type {ValidatorErrorMap} */
      const intermediateErrorMap2 = {};
      /** @type {any} */
      let intermediateResult2 = undefined;
      /** @type {any} */
      const intermediateValue2 = value;

      if (intermediateValue2 === null || intermediateValue2 === undefined) {
        intermediateErrorMap2[`$`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult2 =
          validateStructureReferenceDefinition(intermediateValue2);

        if (refResult2.error) {
          for (const errorKey of Object.keys(refResult2.error)) {
            intermediateErrorMap2[`$${errorKey.substring(1)}`] =
              refResult2.error[errorKey];
          }
        }
        intermediateResult2 = refResult2.value;
      }
      if (Object.keys(intermediateErrorMap2).length > 0) {
        errorMap[`$`].errors.push(intermediateErrorMap2);
      } else {
        hasAnyOfMatch0 = true;
        delete errorMap[`$`];
        result = intermediateResult2;
      }
    }
    if (!hasAnyOfMatch0) {
      /** @type {ValidatorErrorMap} */
      const intermediateErrorMap2 = {};
      /** @type {any} */
      let intermediateResult2 = undefined;
      /** @type {any} */
      const intermediateValue2 = value;

      if (intermediateValue2 === null || intermediateValue2 === undefined) {
        intermediateErrorMap2[`$`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult2 =
          validateStructureRelationDefinition(intermediateValue2);

        if (refResult2.error) {
          for (const errorKey of Object.keys(refResult2.error)) {
            intermediateErrorMap2[`$${errorKey.substring(1)}`] =
              refResult2.error[errorKey];
          }
        }
        intermediateResult2 = refResult2.value;
      }
      if (Object.keys(intermediateErrorMap2).length > 0) {
        errorMap[`$`].errors.push(intermediateErrorMap2);
      } else {
        hasAnyOfMatch0 = true;
        delete errorMap[`$`];
        result = intermediateResult2;
      }
    }
    if (!hasAnyOfMatch0) {
      /** @type {ValidatorErrorMap} */
      const intermediateErrorMap2 = {};
      /** @type {any} */
      let intermediateResult2 = undefined;
      /** @type {any} */
      const intermediateValue2 = value;

      if (intermediateValue2 === null || intermediateValue2 === undefined) {
        intermediateErrorMap2[`$`] = {
          key: "validator.undefined",
        };
      } else {
        const refResult2 =
          validateStructureRouteInvalidationDefinition(intermediateValue2);

        if (refResult2.error) {
          for (const errorKey of Object.keys(refResult2.error)) {
            intermediateErrorMap2[`$${errorKey.substring(1)}`] =
              refResult2.error[errorKey];
          }
        }
        intermediateResult2 = refResult2.value;
      }
      if (Object.keys(intermediateErrorMap2).length > 0) {
        errorMap[`$`].errors.push(intermediateErrorMap2);
      } else {
        hasAnyOfMatch0 = true;
        delete errorMap[`$`];
        result = intermediateResult2;
      }
    }
  }
  if (Object.keys(errorMap).length > 0) {
    return { error: errorMap };
  }
  return { value: result };
}
